/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "camara.h"

camara::camara( QString * cad ){

	estado = new camera_frame;
    	
  ultKeyFrame = 0;
  frameXRibAct = 0;
	
  estado->number = 0;
		
	estado->dx = 10.0;//CAMXFROM;
	estado->dy = 0.0;//CAMYFROM;
	estado->dz = 10.0;//CAMZFROM;

	estado->tx = 0.0;//CAMXTO;
	estado->ty = 0.0;//CAMYTO;
	estado->tz = 0.0;//CAMZTO;
	
	estados.append ( 	estado );
	frameXRibAct = 0;
	
  frameActual = 0;
	this -> cambiarAFrame( 0 );
  cadRib = cad;
  tempCam = new camera_frame;
  modo = false;
  animando = false;
}

camara::~camara(){
}


void camara :: actualizarValores( void )
{
  estado->dx = (dialogo -> xfrom -> text()).toFloat();
  estado->dy = (dialogo -> yfrom -> text()).toFloat();
  estado->dz = (dialogo -> zfrom -> text()).toFloat();
 	estado->tx = (dialogo -> xto -> text()).toFloat();
  estado->ty = (dialogo -> yto -> text()).toFloat();
	estado->tz = (dialogo -> zto -> text()).toFloat();
	emit _actualizarValor( );
}

void camara :: generarInterModif( )
{
	dialogo = new dialogo_camara( 0, "", true );	

	dialogo->xfrom->setValue( (int)( estado -> dx*100 ) ) ;
	dialogo->yfrom->setValue((int)( estado -> dy*100 ) );
	dialogo->zfrom->setValue((int)( estado -> dz*100 ) );
	dialogo->xto->setValue( (int)( estado->tx*100 ) );
	dialogo->yto->setValue( (int)( estado->ty*100 ) );
	dialogo->zto->setValue( (int)( estado->tz*100 ) );
  camera_frame  *temp;  	
 	temp = new camera_frame;
 	*temp = *estado;
 	
	connect( dialogo -> xfrom, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );	
	connect( dialogo -> yfrom, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );	
	connect( dialogo -> zfrom, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
	connect( dialogo -> xto, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
	connect( dialogo -> yto, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
	connect( dialogo -> zto, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
 	
  if ( dialogo -> exec() ) {
    this -> actualizarValores( );
  }
  else
  {
    *estado = *temp;
    dialogo->xfrom->setValue( (int)( temp -> dx*100 ) ) ;
	  dialogo->yfrom->setValue((int)( temp -> dy*100 ) );
	  dialogo->zfrom->setValue((int)( temp -> dz*100 ) );
	  dialogo->xto->setValue( (int)( temp -> tx*100 ) );
	  dialogo->yto->setValue( (int)( temp -> ty*100 ) );
	  dialogo->zto->setValue( (int)( temp -> tz*100 ) );
    emit _actualizarValor( );
  }

  delete dialogo;
}

void camara::record( ){
  	
    if ( estado->number != frameActual )
    {
      camera_frame  *nuevo;  	
    	nuevo = new camera_frame;

      nuevo->number = frameActual;
      nuevo->dx = estado->dx;
 	    nuevo->dy = estado->dy;
      nuevo->dz = estado->dz;

	    nuevo->tx = estado->tx;
	    nuevo->ty = estado->ty;
      nuevo->tz = estado->tz;
	
      estados.append( nuevo );
      this -> cambiarAFrame( frameActual );
    }

    if(frameActual > ultKeyFrame)
    {
      ultKeyFrame = frameActual;
      emit _ultKeyFrame( ultKeyFrame );
    }

}

void camara::cambiarAFrame( int n )
{
  frameActual = n;
  get_frame( );
}

void camara::get_frame( void ){

  uint indice = 0, temp = 0;

	for (uint  n = 0 ; n < estados.count() ; n++ ) {
	
	  estado = estados.at(n);
	
	  if ( estado->number == frameActual ) {
	    indice = n;
	 		break;
	  }		
	  if ( estado->number < frameActual && temp < estado->number ) {
	    temp = estado->number;
	    indice = n;
	  } 		
	}
	
	estado = estados.at( indice );		
	if( !animando )
	  emit _actualizarValor( );
}

void camara :: actualizarCamara( void )
{
	modo = false;
  tempCam = new camera_frame;
 	tempCam -> tx = estado -> dx - estado -> tx;
 	tempCam -> tz = estado -> dz - estado -> tz;
	
  xzlen = sqrt( tempCam -> tx * tempCam -> tx + tempCam -> tz * tempCam -> tz );

  glNewList( 1, GL_COMPILE );
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
    if( xzlen == 0 )
    {
      if( ( estado -> dy - estado -> ty ) > 0 )
        gluLookAt( estado -> dx, estado -> dy, estado -> dz, estado -> tx, estado -> ty, estado -> tz, 0.0, 0.0, 1.0);
      else
        gluLookAt( estado -> dx, estado -> dy, estado -> dz, estado -> tx, estado -> ty, estado -> tz, 0.0, 0.0, 1.0);
    }
    else
      gluLookAt( estado -> dx, estado -> dy, estado -> dz, estado -> tx, estado -> ty, estado -> tz, 0.0, 1.0, 0.0);
  glEndList();
}

void camara :: generarCodRIB( void )
{ 	
  QString * tempo;
 	
 	tempCam = new camera_frame;
 	
 	*tempCam = *estado;
 	
 	tempCam -> tz *= -1;
 	tempCam -> dz *= -1;
 	
 	tempo = new QString( );
 	
 	tempCam -> tx -= tempCam -> dx;
 	tempCam -> ty -= tempCam -> dy;
 	tempCam -> tz -= tempCam -> dz;

  cadRib -> truncate( 0 );

  if( ( uint )( estados . at() ) == frameActual )
	  cadRib -> append( "#KEYFRAME\n\n" );
	
  tempo -> sprintf( "#CAMARA: %.2f %.2f %.2f %.2f %.2f %.2f\n\n", estado -> dx, estado -> dy, estado -> dz, estado -> tx, estado -> ty, estado -> tz);

  cadRib -> append( * tempo );
  cadRib -> append( "Identity\n" );

  if( !( tempCam -> tx == 0 && tempCam -> ty == 0 && tempCam -> tz == 0 ) )
  {
    xzlen = sqrt( tempCam -> tx * tempCam -> tx + tempCam -> tz * tempCam -> tz );

    if( xzlen == 0 )
      yrot = ( tempCam -> ty < 0 ) ? 180 : 0;
    else
      yrot = 180 * acos( tempCam -> tz / xzlen ) / M_PI;

    yzlen = sqrt( tempCam -> ty * tempCam -> ty + xzlen * xzlen );
    xrot = 180 * acos( xzlen / yzlen ) / M_PI;

    if( tempCam -> ty > 0 )
    {
      tempo -> sprintf( "Rotate %.2f 1.0 0.0 0.0\n", xrot );
      cadRib -> append( * tempo );
    }
    else
    {
      tempo -> sprintf( "Rotate %.2f 1.0 0.0 0.0\n", -1 *xrot );
      cadRib -> append( * tempo );
    }

    if( tempCam -> tx > 0 )
    {
      tempo -> sprintf( "Rotate %.2f 0.0 1.0 0.0\n", -1 *yrot );
      cadRib -> append( * tempo );
    }
    else
    {
      tempo -> sprintf( "Rotate %.2f 0.0 1.0 0.0\n", yrot );
      cadRib -> append( * tempo );
    }
  }

  tempo -> sprintf( "Translate %.2f %.2f %.2f\n", -1 * tempCam -> dx, -1 * tempCam -> dy, -1 * tempCam -> dz );
  cadRib -> append( * tempo );

  if( !animando )
    emit _RIBOk( );
  else
  {
    animando = false;
    emit _animOk( );
  }
}

void camara :: genRIBFrame( uint donde )
{
  uint tempo;

  animando = true;
  tempo = frameActual;
  this -> cambiarAFrame( donde );
  this -> generarCodRIB();
  this -> cambiarAFrame( tempo );
}

void camara :: record( uint a, float dx, float dy, float dz, float tx, float ty, float tz )
{
  this -> cambiarAFrame( a );
  this -> record( );
  estado -> dx = dx;
  estado -> dy = dy;
  estado -> dz = dz;
  estado -> tx = tx;
  estado -> ty = ty;
  estado -> tz = tz;
}

void camara :: genFrameXRib( QString * donde )
{
  QString  * tempoC;

  tempoC = new QString();

  donde -> truncate(0);

	for (uint  n = 0 ; n < estados.count() ; n++ )
	{
	
		tempoC -> sprintf( "\nFRAME\n%d\nCAMARA\n%.2f %.2f %.2f %.2f %.2f %.2f ", estados.at(n) -> number, estados.at(n) -> dx, estados.at(n) -> dy, estados.at(n) -> dz, estados.at(n) -> tx, estados.at(n) -> ty, estados.at(n) -> tz );
		donde -> append( *tempoC );
	}
	
	emit _finXRIB( );
}

void camara :: interpolar( void )
{
  uint lim, max;
  camera_frame * temp, * fin;
  float a, b, c, d, e, f;

  fin = 0;

  max = estados.count();

  for(uint i = 0, h; i < max; ++i)
  {
    temp = estados.at(i);

    lim = ultKeyFrame;

    if(temp -> number == ultKeyFrame)
      continue;
    for(h = 0; h < max; ++h)
   	{
   	  if( estados.at(h) -> number > temp -> number && estados.at(h) -> number <= lim)
   	  {
   	    lim = estados.at(h) -> number;
   	    fin = estados.at(h);
	 	  }
   	}
      	
    if( max > 0 )
    {
	   	a = ( fin -> dx ) - ( temp -> dx );
	   	b = ( fin -> dy ) - ( temp -> dy );  	 	
	   	c = ( fin -> dz ) - ( temp -> dz );  	 	
	   	d = ( fin -> tx ) - ( temp -> tx );  	 	
	   	e = ( fin -> ty ) - ( temp -> ty );  	 	
	   	f = ( fin -> tz ) - ( temp -> tz );  	 	
  	 	
  	 	a /= ( fin -> number ) - ( temp -> number );
  	 	b /= ( fin -> number ) - ( temp -> number );
  	 	c /= ( fin -> number ) - ( temp -> number );
  	 	d /= ( fin -> number ) - ( temp -> number );
  	 	e /= ( fin -> number ) - ( temp -> number );
  	 	f /= ( fin -> number ) - ( temp -> number );

     	for( h = temp -> number + 1; h < fin -> number; ++h )
    	{
    	  this -> cambiarAFrame( h );
		   	this -> record( );
		   	( estado -> dx ) = ( temp -> dx ) + a * ( h - temp -> number );
		   	( estado -> dy ) = ( temp -> dy ) + b * ( h - temp -> number );
		   	( estado -> dz ) = ( temp -> dz ) + c * ( h - temp -> number );
		   	( estado -> tx ) = ( temp -> tx ) + d * ( h - temp -> number );
		   	( estado -> ty ) = ( temp -> ty ) + e * ( h - temp -> number );
		   	( estado -> tz ) = ( temp -> tz ) + f * ( h - temp -> number );
	  	}      	
   	}
  }

  emit _interpolarFin( );
}

