/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CAMARA_H
#define CAMARA_H

#include <defines.h>
#include "dialogo_camara.h"
#include "spinboxf.h"

/**
  *@author Vctor Javier Cerquera
  */

typedef struct
{
	uint number;
  float dx, dy, dz, tx, ty, tz;
} camera_frame;

class camara : public QObject
{
	Q_OBJECT
	
	public:
		
		camara( QString * );
		~camara();

    void get_frame( void );

    uint frameActual;
    uint ultKeyFrame;
    uint frameXRibAct;

    bool modo;
    bool animando;

	  camera_frame *estado;
	  camera_frame *tempCam;  	
	
	  QString * cadRib;
	
	  double xzlen;
	  double yzlen;
	  double yrot;
	  double xrot;
	 	
	 	dialogo_camara * dialogo;
	
	public slots:

    void generarCodRIB( void ); 	
	  void generarInterModif( void );
	  void record( void );
	  void actualizarCamara( void );
	  void actualizarValores( void );
	  void cambiarAFrame( int );
    void genRIBFrame( uint );
    void genFrameXRib( QString * );
    void record( uint, float, float, float, float, float, float );
		void interpolar( void );


  signals:

    void _actualizarValor( void );
	  void _RIBOk( void );  	
	  void _animOk( void );
	  void _interpolarFin( void );
		void _frameOK( void );
		void _finXRIB( void );
	  void _ultKeyFrame( uint );
		
	protected:
	
	  QList<camera_frame>  estados;
		
};

#endif
