/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "control.h"

control :: control( QObject* parent, const char* name )
				: QObject( parent, name )
{

	ultKeyFrameN = 0;
	ventPpal = new interfaz( this );
	prim = new VectorP( );
	cadsR = new VectorC( );
	primOK = 0;
	interp = 0;
	nombOK = 0;
	RIBOk = 0;
	encabOK = 0;
	ensambOK = 0;
	animando = false;
	salvando = false;
	tempC = new QString( );
	luz = new QString( );
	cadEx = new QString();
	world = new mundo( this, "Mundo", tempC, luz );
	lista = new QStringList( );
	matT	= new Matrix( 4, 4 );
	matT -> Unit( );
	cadsR -> resize( 5 );
	cadsR -> insert( cadsR -> count(), tempC );
  tempC = 0;
	dialRen = new dialogo_render_imp( 0, "" );
	dialRenGL = new dialogo_rendergl( 0, "", true );
	backgroundC = new QColor( 0, 0, 0 );

	anchoRIB = 640;
	altoRIB = 480;
	frameIniRIB = 0;
	frameFinRIB = 100;
	fpsRIB = 30;
	detailRIB = 1.0;
	cerrarRIB = false;
	estiloRIB = 0;
	
	xsamplesRIB = 1;
	ysamplesRIB = 1;
	scanlinesRIB = 1;
	
	cropRIB = false;
	xMinCropRIB = 0.0;
	yMinCropRIB = 0.0;
	xMaxCropRIB = 1.0;
	yMaxCropRIB = 1.0;
	
	radRIB = false;
	radStepsRIB = 1;
	radSamplesRIB = 2;
		
	saveRIB = false;
	fileRIB = new QString( );	
	
	connect( this, SIGNAL( _nombresOK( void ) ), this, SLOT( mostrarDialogoSeleccion( void ) ) );
	connect( this, SIGNAL( _finGenArch( void ) ), this, SLOT( ejecutarAnim( void ) ) );
	connect( this, SIGNAL( _finGenArchSalvar( void ) ), this, SLOT( salvarArchivo( void ) ) );
	
	connect( this, SIGNAL( _camera_edit( void ) ), world, SIGNAL( _camera_edit( void ) ) );
	connect( this, SIGNAL( _cambiarAFrame( int ) ), world, SIGNAL( _cambiarAFrame( int ) ) );
	connect( this, SIGNAL( _actualizarGL( void ) ), world, SIGNAL( _actualizarGL( void ) ) );
	connect( this, SIGNAL( _record( void ) ), world, SIGNAL( _record( void ) ) );
	connect(this, SIGNAL( _record( uint, float, float, float, float, float, float ) ), world, SIGNAL( _record( uint, float, float, float, float, float, float ) ) );	
	connect( this, SIGNAL( _actualizarRIB( void ) ), world, SLOT( generarCodRIB( void ) ) );
	connect( world, SIGNAL( _animOk( void ) ), this, SLOT( animar( void ) ) );
  connect( this, SIGNAL( _genRIBFrame( uint ) ), world, SLOT( genRIBFrame( uint ) ) );
	connect( this, SIGNAL( _dialogo_crear_ambiental( void ) ), world, SLOT( addAmb( void ) ) );	
	connect( this, SIGNAL( _dialogo_crear_omni( void ) ), world, SLOT( addOmn( void ) ) );	
	connect( this, SIGNAL( _dialogo_crear_spot( void ) ), world, SLOT( addSpo( void ) ) );
	connect( this, SIGNAL( _dialogo_crear_ambiental( float, float, float, float ) ), world, SLOT( addAmb( float, float, float, float ) ) );	
	connect( this, SIGNAL( _dialogo_crear_omni( float, float, float, float, float, float, float ) ), world, SLOT( addOmn( float, float, float, float, float, float, float ) ) );	
	connect( this, SIGNAL( _dialogo_crear_spot( float, float, float, float, float, float, float, float, float, float, float, float, float ) ), world, SLOT( addSpo( float, float, float, float, float, float, float, float, float, float, float, float, float ) ) );	
	
	connect( this, SIGNAL( _obtFramesXRib( void ) ), world, SLOT( frameXRIB( void ) ) );	
	connect( this, SIGNAL( _obtEncabezadoXRib( void ) ), world, SLOT( encabezadoXRIB( void ) ) );	
}

control :: ~control()
{
}

void control :: dialogo_crear( int cual )
{
	char nombre[20];
	
	lastPrim = cual;
	
	switch( cual )
	{
		case BOX:			
		  sprintf( nombre, "BOX%d", prim -> count() + 1);

		  tempC = new QString();
		  		
			tempP = ( primitiva * ) new primPrisma( this, nombre, 100, (prim -> count() + 1)*2 + 2, tempC );
			
		 	break;
		
		case TORUS:			
		
		  sprintf( nombre, "TORUS%d", prim -> count() + 1);

		  tempC = new QString();
		  		
			tempP = ( primitiva * ) new primToro( this, nombre, 100, (prim -> count() + 1)*2 + 2, tempC );
			
			
		 	break;
		
		case SPHERE:			
		
		  sprintf( nombre, "SPHERE%d", prim -> count() + 1);

		  tempC = new QString();
		  		
			tempP = ( primitiva * ) new primEsfera( this, nombre, 100, (prim -> count() + 1)*2 + 2, tempC );
			
			
		 	break;
		 	
		case DISK:			
		
		  sprintf( nombre, "DISK%d", prim -> count() + 1);

		  tempC = new QString();
		  		
			tempP = ( primitiva * ) new primDisco( this, nombre, 100, (prim -> count() + 1)*2 + 2, tempC );
			
		 	break;
		 	
		case HYPERBOLOID:			
		
		  sprintf( nombre, "HYPERBOLOID%d", prim -> count() + 1);

		  tempC = new QString();
		  		
			tempP = ( primitiva * ) new primHyper( this, nombre, 100, (prim -> count() + 1)*2 + 2, tempC );
						
		 	break; 	

		case CYLINDER:			
		
		  sprintf( nombre, "CYLINDER%d", prim -> count() + 1);

		  tempC = new QString();
		  		
			tempP = ( primitiva * ) new primCilindro( this, nombre, 100, (prim -> count() + 1)*2 + 2, tempC );
						
		 	break;
		
		case CONE:			
		
		  sprintf( nombre, "CONE%d", prim -> count() + 1);

		  tempC = new QString();
		  		
			tempP = ( primitiva * ) new primCono( this, nombre, 100, (prim -> count() + 1)*2 + 2, tempC );
			
		 	break;
		 			 	 	 			 			
  	case CAMERA:
		 	emit _camera_edit( );
		 	break;	
		
		case ABOUT:
		 	
		 	dialogo_about *about;
		 	
		 	about = new dialogo_about(0,0,true);
		 	
		 	about->exec();
		 	
		 	delete about;
		
		 	break;
	}
	
	if( cual != CAMERA && cual != ABOUT )
	{			
			connect( this, SIGNAL( _generarInterCreac( void ) ), tempP, SLOT( generarInterCreac( void ) ) );
			connect( tempP, SIGNAL( _objetoCreado( void ) ), this, SLOT( primCreada( void ) ) );
			connect( tempP, SIGNAL( _objetoNoCreado( void ) ), this, SLOT( primNoCreada( void ) ) );
			connect( this, SIGNAL( _actualizarRIB( void ) ), tempP, SLOT( generarCodRIB( void ) ) );
			connect( this, SIGNAL( _actualizarGL( void ) ), tempP, SLOT( generarCodGL( void ) ) );
			connect( tempP, SIGNAL( _actualizacionPrimOK( void ) ), this, SLOT( actualizarPrims( void ) ) );
		  connect( tempP, SIGNAL( _actualizarValor( void ) ), this, SIGNAL( _actualizarGL( void ) ) );
		  connect( this, SIGNAL( _cambiarAFrame( int ) ), tempP, SLOT( cambiarAFrame( int ) ) );
		  connect( this, SIGNAL( _material( QString * ) ), tempP, SLOT( material( QString * ) ) );
			connect( tempP, SIGNAL( _nombre( QString ) ), this, SLOT( addLista( QString ) ) );
		  connect( this, SIGNAL( _getNombres( void ) ), tempP, SLOT( getNombre( void ) ) );
		  connect( this, SIGNAL( _interpolar( void ) ), tempP, SLOT( interpolar( void ) ) );
		  connect( tempP, SIGNAL( _interpolarFin( void ) ), this, SLOT( interpolarFin( void ) ) );
			connect( this, SIGNAL( _seleccionar( QString, bool ) ), tempP, SLOT( seleccionar( QString, bool ) ) );
			connect( tempP, SIGNAL( _revisarNombre( const QString & ) ), this, SLOT( revisarNombre( const QString & ) ) );
		  connect( this, SIGNAL( _getNombresValidar( void ) ), tempP, SLOT( validarNombre( void ) ) );
			connect( tempP, SIGNAL( _validarNombre( QString ) ), this, SLOT( validarNombres( QString ) ) );
			connect( this, SIGNAL( _record( void ) ), tempP, SLOT( record( void ) ) );
			connect( this, SIGNAL( _record( Matrix, QString *, uint ) ), tempP, SLOT( addTransf( Matrix, QString *, uint ) ) );
		  connect( this, SIGNAL( _resetPreview( void ) ), tempP, SLOT( resetPreview( void ) ) );
			connect( this, SIGNAL( _moverPreview( Matrix ) ), tempP, SLOT( addPreview( Matrix ) ) );
			connect( this, SIGNAL( _moverTransf( Matrix ) ), tempP, SLOT( addTransf( Matrix ) ) );
			connect( this, SIGNAL( _rotarPreview( Matrix ) ), tempP, SLOT( addPreview( Matrix ) ) );
			connect( this, SIGNAL( _rotarTransf( Matrix ) ), tempP, SLOT( addTransf( Matrix ) ) );
			connect( this, SIGNAL( _escalarPreview( Matrix ) ), tempP, SLOT( addPreview( Matrix ) ) );
			connect( this, SIGNAL( _escalarTransf( Matrix ) ), tempP, SLOT( addTransf( Matrix ) ) );
			connect( this, SIGNAL( _recortePreview( Matrix ) ), tempP, SLOT( addPreview( Matrix ) ) );
			connect( this, SIGNAL( _recorteTransf( Matrix ) ), tempP, SLOT( addTransf( Matrix ) ) );
			connect( this, SIGNAL( _mirrorPreview( Matrix ) ), tempP, SLOT( addPreview( Matrix ) ) );
			connect( this, SIGNAL( _mirrorTransf( Matrix ) ), tempP, SLOT( addTransf( Matrix ) ) );
  		connect( this, SIGNAL( _genRIBFrame( uint ) ), tempP, SLOT( genRIBFrame( uint ) ) );
			connect( tempP, SIGNAL( _animOk( void ) ), this, SLOT( animar( void ) ) );
			connect( this, SIGNAL( _obtFramesXRib( void ) ), tempP, SLOT( genFrameXRib( void ) ) );	
			connect( this, SIGNAL( _obtEncabezadoXRib( void ) ), tempP, SLOT( encabezadoXRIB( void ) ) );	
      connect( tempP, SIGNAL( _frameOK( void ) ), this, SLOT( ensamblarXRIB( void ) ));
			connect( tempP, SIGNAL( _finXRIB( void ) ), this, SLOT( generarXRIB( void ) ));
			connect( tempP, SIGNAL( _encabezadoOK( void ) ), this, SLOT( genEncabezadoRIB( void ) ));
		
		  emit _actualizarGL( );
		  emit _generarInterCreac( );
	}
}

void control :: record( )
{
 	emit _record( );
}

void control :: primCreada( void )
{
	if( prim -> count() == prim -> size())
	{
	  prim -> resize( prim -> size() + 5 );
	}
	
  prim -> insert( prim -> count(), tempP );

  tempP = 0;
	
	if( cadsR -> count() == cadsR -> size())
	{
	  cadsR -> resize( cadsR -> size() + 5 );
	}
	
  cadsR -> insert( cadsR -> count(), tempC );

  tempC = 0;

  emit _actualizarGL( );
  emit _rePaint( );
}

void control :: primNoCreada( void )
{
  delete tempP;
	delete tempC;
	glDeleteLists( (prim -> count() + 1)*2 + 2, 1 );
  emit _actualizarGL( );
  emit _rePaint( );
}

interfaz * control :: getInterfaz( void )
{
  return ventPpal;
}

void control::construirListaPrims( void )
{
  if(glIsList( primsGL ))
   	glDeleteLists( primsGL, 1 );
  glNewList( primsGL, GL_COMPILE );
  if(tempP == 0)
    for( uint i = 1; i <= prim -> count(); ++i )
    {
      if(glIsList(i*2 + 2))
        glCallList( i*2 + 2 );
    }
  else
    for( uint i = 1; i <= prim -> count() + 1; ++i )
    {
      if(glIsList(i*2 + 2))
        glCallList( i*2 + 2 );
    }
	glEndList();
}

void control::actualizarPrims( void )
{
  ++primOK;
  if( tempP == 0 && primOK == prim -> count())
  {
    this -> construirListaPrims( );
    emit _rePaint();
    primOK = 0;
  }
  if( tempP != 0 && primOK == (prim -> count()) + 1)
  {
    this -> construirListaPrims( );
    emit _rePaint();
    primOK = 0;
  }
}

void control::iniciar( void )
{
	primsGL = 2;
	
	/* Cmara */
	
	glNewList( 1, GL_COMPILE );
    gluLookAt(CAMXFROM, CAMYFROM, CAMZFROM, CAMXTO, CAMYTO, CAMZTO, 0.0, 1.0, 0.0);
    glRotatef( CAMROLL, 0.0, 0.0, 1.0 );
  glEndList();

  glNewList( primsGL, GL_COMPILE );
  glEndList();

	emit _cambiarModoVisual( 3, 1 );
 	emit _cambiarModoVisual( 0, 0 );
	emit _cambiarModoVisual( 1, 0 );
  emit _cambiarModoVisual( 2, 0 );

 	emit _cambiarCamara( 0, 3 );
	emit _cambiarCamara( 1, 7 );
  emit _cambiarCamara( 2, 5 );
  emit _cambiarCamara( 3, 1 );

  emit _inicializar( );
}

void control :: addLista( QString nombre )
{
  if( nombOK == 0 )
    lista = new QStringList( );

  ++nombOK;
  lista -> append( nombre );

  if( nombOK == prim -> count() )
  {
    lista -> sort( );
    nombOK = 0;
    emit _nombresOK( );
  }
}

void control :: actualizarSeleccion( void )
{
  for( uint i = 0; i < dialSel -> lista_objetos -> count( ); ++i)
  {
    dialSel -> lista_objetos -> setCurrentItem( i );
    emit _seleccionar( dialSel -> lista_objetos -> currentText(), dialSel -> lista_objetos -> isSelected( i ) );
  }
  emit _actualizarGL( );
}

void control :: mostrarDialogoSeleccion( void )
{
  dialSel = new dialogo_seleccion( 0, 0, true );

  dialSel -> lista_objetos -> insertStringList( * lista );

  connect( dialSel -> lista_objetos, SIGNAL( selectionChanged( void ) ), this, SLOT( actualizarSeleccion( void ) ) );

  if( dialSel -> exec() )
  {
    this -> actualizarSeleccion( );
  }

  delete dialSel;
}

void control :: dialogoSeleccion( void )
{
  emit _getNombres( );
}

void control :: revisarNombre( const QString & nombre )
{
  nomValidacion = new QString( nombre );
  emit _getNombresValidar( );
}

void control :: validarNombres( QString nombre )
{
  if( nombre == * nomValidacion )
  {
    QMessageBox::information( 0, "XRib","There's already another object with this name.\nIf you continue, the object will become a group and can't be ungrouped." );
  }
}

void control :: mover( void )
{
	dialMov = new dialogo_mover( 0, 0, true );

  connect( dialMov -> X, SIGNAL( valueChanged( int ) ), this, SLOT( moverPreview( void ) ) );
  connect( dialMov -> Y, SIGNAL( valueChanged( int ) ), this, SLOT( moverPreview( void ) ) );
  connect( dialMov -> Z, SIGNAL( valueChanged( int ) ), this, SLOT( moverPreview( void ) ) );

  if( dialMov -> exec() )
  {
    this -> moverTransf( );
  }
  else
  	emit _resetPreview( );

	delete dialMov;
}

void control :: rotar( void )
{
	dialRot = new dialogo_rotar( 0, 0, true );

  connect( dialRot -> x, SIGNAL( valueChanged( int ) ), this, SLOT( rotarPreview( void ) ) );
  connect( dialRot -> y, SIGNAL( valueChanged( int ) ), this, SLOT( rotarPreview( void ) ) );
  connect( dialRot -> z, SIGNAL( valueChanged( int ) ), this, SLOT( rotarPreview( void ) ) );
  if( dialRot -> exec() )
  {
    this -> rotarTransf( );
  }
  else
  	emit _resetPreview( );

	delete dialRot;
}

void control :: escalar( void )
{
	dialEsc = new dialogo_escalar( 0, 0, true );

  connect( dialEsc -> X, SIGNAL( valueChanged( int ) ), this, SLOT( escalarPreview( void ) ) );
  connect( dialEsc -> Y, SIGNAL( valueChanged( int ) ), this, SLOT( escalarPreview( void ) ) );
  connect( dialEsc -> Z, SIGNAL( valueChanged( int ) ), this, SLOT( escalarPreview( void ) ) );

  if( dialEsc -> exec() )
  {
    this -> escalarTransf( );
  }
  else
  	emit _resetPreview( );

	delete dialEsc;
}

void control :: recorte( void )
{
	dialRec = new dialogo_recorte( 0, 0, true );

  connect( dialRec -> a, SIGNAL( valueChanged( int ) ), this, SLOT( recortePreview( void ) ) );
  connect( dialRec -> b, SIGNAL( valueChanged( int ) ), this, SLOT( recortePreview( void ) ) );
  connect( dialRec -> recorte, SIGNAL( clicked( int ) ), this, SLOT( recortePreview( void ) ) );

  if( dialRec -> exec() )
  {
    this -> recorteTransf( );
  }
  else
  	emit _resetPreview( );

	delete dialRec;
}

void control :: mirror( void )
{
	dialMir = new dialogo_mirror( 0, 0, true );

  connect( dialMir -> X, SIGNAL( toggled( bool ) ), this, SLOT( mirrorPreview( void ) ) );
  connect( dialMir -> Y, SIGNAL( toggled( bool ) ), this, SLOT( mirrorPreview( void ) ) );
  connect( dialMir -> Z, SIGNAL( toggled( bool ) ), this, SLOT( mirrorPreview( void ) ) );

  if( dialMir -> exec() )
  {
    this -> mirrorTransf( );
  }
  else
  	emit _resetPreview( );

	delete dialMir;
}

void control :: material( void )
{
	dialogo_material *dialogo;

	QString  *material;
	QString  *tempo;
	QColor   *color;

 	 tempo = new QString( );
 	 material = new QString ( );
	
	 dialogo = new dialogo_material(0,0,true);
	 dialogo -> surface -> setSelected ( 5 , true );

	
	if ( dialogo->exec() )
	{	
		color = new QColor( dialogo -> color_objeto -> color_object . rgb () );
		tempo -> sprintf( "Color [ %.2f %.2f %.2f ]\n", (float)(color -> red( ))/255.0, (float)(color -> green( ))/255.0, (float)(color -> blue( ))/255.0 );
	 	material -> append( * tempo );
	
		color->setRgb( dialogo -> color_specular -> color_object . rgb () );	
	
   	tempo -> sprintf( "Surface \"%s\" \"Ka\" %.2f \"Kd\" %.2f \"Ks\" %.2f \"roughness\" %.2f \"specularcolor\" [%.2f  %.2f %.2f]\n",
    										( dialogo->surface->currentText( ) ).latin1(),
    										( dialogo -> Ka -> text() ).toFloat(),
    										( dialogo -> Kd -> text() ).toFloat(),
    										( dialogo -> Ks -> text() ).toFloat(),
    										( dialogo -> roughness -> text() ).toFloat(),
										 		(float)(color -> red( ))/255.0,
										 		(float)(color -> green( ))/255.0,
										 		(float)(color -> blue( ))/255.0 );
										
   	material -> append( * tempo );
	  emit _material( material );
	  delete color;
	}
	
  delete dialogo;
  delete tempo;
}

void control :: calcularMatrizMover( void )
{
	matT -> Unit( );
	(*matT)( 0, 3 ) = ( dialMov -> X -> text() ).toFloat();
	(*matT)( 1, 3 ) = ( dialMov -> Y -> text() ).toFloat();
	(*matT)( 2, 3 ) = ( dialMov -> Z -> text() ).toFloat();
}

void control :: moverPreview( void )
{
  this -> calcularMatrizMover( );

  emit _moverPreview( *matT );
}

void control :: moverTransf( void )
{
  this -> calcularMatrizMover( );

  emit _moverTransf( *matT );
}

void control :: calcularMatrizRotar( void )
{
  Matrix * temp;

  float a, b, c;

  temp = new Matrix( 4, 4 );
  matT -> Unit( );
  c = ( dialRot -> x -> value() ) * 2 * M_PI / 36000.0;
  a = sin( c );
  b = cos( c );
  temp -> Unit( );
  (*temp)( 1, 1 ) = b;
  (*temp)( 1, 2 ) = -a;
  (*temp)( 2, 1 ) = a;
  (*temp)( 2, 2 ) = b;
  *matT *= *temp;
  c = ( dialRot -> y -> value() ) * 2 * M_PI / 36000.0;
  a = sin( c );
  b = cos( c );
	temp -> Unit( );
	(*temp)( 0, 0 ) = b;
  (*temp)( 0, 2 ) = a;
  (*temp)( 2, 0 ) = -a;
  (*temp)( 2, 2 ) = b;
  *matT *= *temp;
  c = ( dialRot -> z -> value() ) * 2 * M_PI / 36000.0;
  a = sin( c );
  b = cos( c );
  temp -> Unit( );
  (*temp)( 0, 0 ) = b;
  (*temp)( 0, 1 ) = -a;
  (*temp)( 1, 0 ) = a;
  (*temp)( 1, 1 ) = b;
  *matT *= *temp;
}

void control :: rotarPreview( void )
{
  this -> calcularMatrizRotar( );

  emit _rotarPreview( *matT );
}

void control :: rotarTransf( void )
{
  this -> calcularMatrizRotar( );

  emit _rotarTransf( *matT );
}

void control :: calcularMatrizEscalar( void )
{
	matT -> Unit( );
	(*matT)( 0, 0 ) = ( dialEsc -> X -> text() ).toFloat();
	(*matT)( 1, 1 ) = ( dialEsc -> Y -> text() ).toFloat();
	(*matT)( 2, 2 ) = ( dialEsc -> Z -> text() ).toFloat();
}

void control :: escalarPreview( void )
{
  this -> calcularMatrizEscalar( );

  emit _escalarPreview( *matT );
}

void control :: escalarTransf( void )
{
  this -> calcularMatrizEscalar( );

  emit _escalarTransf( *matT );
}


void control :: calcularMatrizrecorte( void )
{
  float a, b;

  a = ( dialRec -> a -> text() ).toFloat();
  b = ( dialRec -> b -> text() ).toFloat();

  switch( dialRec -> recorte ->id( dialRec -> recorte -> selected( ) ) )
	{
	  case 0:
	    matT -> Unit( );
	    (*matT)( 1, 0 ) = a;
	    (*matT)( 2, 0 ) = b;
	    break;
	  case 1:
	    matT -> Unit( );
	    (*matT)( 0, 1 ) = a;
	    (*matT)( 2, 1 ) = b;
	    break;
	  case 2:
	    matT -> Unit( );
	    (*matT)( 0, 2 ) = a;
	    (*matT)( 1, 2 ) = b;
	    break;
	}
}

void control :: recortePreview( void )
{
  this -> calcularMatrizrecorte( );

  emit _recortePreview( *matT );
}

void control :: recorteTransf( void )
{
  this -> calcularMatrizrecorte( );

  emit _recorteTransf( *matT );
}

void control :: calcularMatrizMirror( void )
{
  matT -> Unit( );

  if( dialMir -> X -> isChecked( ) )
    (*matT)( 0, 0 ) = -1;

  if( dialMir -> Y -> isChecked( ) )
    (*matT)( 1, 1 ) = -1;

  if( dialMir -> Z -> isChecked( ) )
    (*matT)( 2, 2 ) = -1;
}

void control :: mirrorPreview( void )
{
  this -> calcularMatrizMirror( );

  emit _mirrorPreview( *matT );
}

void control :: mirrorTransf( void )
{
  this -> calcularMatrizMirror( );

  emit _mirrorTransf( *matT );
}

void control :: actualizarRIB( void )
{
	salidaRIB = new ofstream( "./XRibSwap.dat" );
  if(salvando)
    this -> generarArchivo();
  else
    if(modoGL)
    {
      if( dialRenGL -> exec( ) )
      {
        anchoRIB = dialRenGL -> xres -> value( );
	      altoRIB = dialRenGL -> yres -> value( );
	 			frameIniRIB = dialRenGL -> from -> value( );
				frameFinRIB = dialRenGL -> to -> value( );
				fpsRIB = dialRenGL -> sync -> value( );
				detailRIB = ( dialRenGL -> rd -> text( ) ) . toFloat();
				cerrarRIB = dialRenGL -> nowait -> isChecked( );
				estiloRIB = dialRenGL -> style -> id( dialRenGL -> style -> selected( ) );

				sprintf(cadena, "rgl -rd %.2f -sync %d -unlit", detailRIB, fpsRIB );
				
				if( cerrarRIB )		
				  sprintf(cadena, "%s -nowait", cadena );
				
				if( estiloRIB == 1 )		
				  sprintf(cadena, "%s -lines", cadena );
				
				if( estiloRIB == 2 )		
				  sprintf(cadena, "%s -sketch", cadena );
				
				sprintf(cadena, "%s ./XRibSwap.dat", cadena );
				this -> generarArchivo( );
      }
    }
    else
    {
      if( dialRen -> exec( ) )
      {
				anchoRIB = dialRen -> xres -> value( );
				altoRIB = dialRen -> yres -> value( );
				frameIniRIB = dialRen -> from -> value( );
				frameFinRIB = dialRen -> to -> value( );

				xsamplesRIB = dialRen -> xsamples -> value( );
				ysamplesRIB = dialRen -> ysamples -> value( );
				scanlinesRIB = dialRen -> scanline -> value( );
	
				cropRIB = dialRen -> crop -> isChecked( );
				xMinCropRIB = ( dialRen -> xmin -> text( ) ) . toFloat();
				yMinCropRIB = ( dialRen -> ymin -> text( ) ) . toFloat();
				xMaxCropRIB = ( dialRen -> xmax -> text( ) ) . toFloat();
				yMaxCropRIB = ( dialRen -> ymax -> text( ) ) . toFloat();
	
				radRIB = dialRen -> radio -> isChecked( );
				radStepsRIB = dialRen -> steps -> value( );
				radSamplesRIB = dialRen -> rsamples -> value( );
			
				saveRIB = dialRen -> save -> isChecked( );
				*fileRIB = dialRen -> filename -> text( );	
	
				if ( fileRIB->isEmpty() ){
					*fileRIB = "ri_temp";
				}
				
				if ( *fileRIB)
				sprintf( cadena, " " );
				
				if( cropRIB )
        	sprintf( cadena, "-crop %.2f %.2f %.2f %.2f ", xMinCropRIB, xMaxCropRIB, yMinCropRIB, yMaxCropRIB );

				if( radRIB )
				  sprintf( cadena, "%s -radio %d -rsamples %d ", cadena, radStepsRIB, radSamplesRIB );
				
        this -> generarArchivo( );
      }
    }
}

void control :: render( void )
{
  modoGL = false;
  this -> actualizarRIB( );
}

void control :: renderGL( void )
{
  modoGL = true;
  this -> actualizarRIB( );
}

void control :: animar( void )
{
  if( animando )
  {
    ++primAnimOk;

    if( primAnimOk == cadsR -> count( ) )
    {
      ( * salidaRIB ) << "FrameBegin " << animAct << endl;
      if ( !( backgroundC -> red() == 0 && backgroundC -> green() == 0 && backgroundC -> blue() == 0 ) )
      	( * salidaRIB ) << "\nImager \"background\" \"background\" " << backgroundC -> red() / 255.0 << " " << backgroundC -> green() / 255.0 << " " << backgroundC -> blue() / 255.0 << endl;
      ( * salidaRIB ) << "WorldBegin" << endl;

      ( * salidaRIB ) << *( cadsR -> at( 0 ) );

      ( * salidaRIB ) << * luz << endl;

      for( uint i = 1; i < cadsR -> count( ); ++i )
  	    ( * salidaRIB ) << *( cadsR -> at( i ) );
    	
    	( * salidaRIB ) << "WorldEnd" << endl;
  	  ( * salidaRIB ) << "FrameEnd" << endl;
  	
      if( animAct == frameFinRIB )
      {
        animando = false;
	      salidaRIB -> close();
	      primAnimOk = 0;
  	    delete salidaRIB;
  	    if(salvando)
  	    {
  	    	emit _finGenArchSalvar( );
  	    }
  	    else
  	    	emit _finGenArch( );
  	    salvando = false;
      }
      else
      {
        ++animAct;
        primAnimOk = 0;
        emit _genRIBFrame( animAct );
      }

    }
  }
}

void control :: fov( GLdouble dato )
{
  fovD = dato;
}


void control :: ejecutarAnim( void )
{
  if( modoGL )
  {
		ventPpal -> setCursor( waitCursor );
		ventPpal -> setCaption( "Procesing OpenGL Preview ... Please Wait" );
    system( cadena );
  	ventPpal -> setCursor( arrowCursor );
		ventPpal -> setCaption( "XRib - The Animation Software for Linux" );
  }
  else
  {
	
    if( saveRIB )
		{
		
				QString *exec_cad;
				exec_cad = new QString();


			switch ( dialRen->save_settings-> id( dialRen->save_settings -> selected( ) )   )	 {
				
				case 0 :	// grabar actual frame
						exec_cad->truncate(0);
						exec_cad->sprintf("echo \"Display \\\"%s.tiff\\\" \\\"file\\\" \\\"rgba\\\"\" > XRibSwap.tmp ",fileRIB->latin1());
						system(exec_cad->latin1());
						exec_cad->truncate(0);
						exec_cad->sprintf("cat XRibSwap.dat >> XRibSwap.tmp ");
						system(exec_cad->latin1());

					    if (   dialRen->network-> id(  dialRen->network -> selected( )  ) )
					    {
	            	exec_cad->truncate(0);	
								exec_cad ->append("farm ./XRibSwap.tmp" ); 	
 								ventPpal -> setCursor( waitCursor );
								ventPpal -> setCaption( "Net Rendering ... Please Wait." );
								system(exec_cad->latin1());
						  	ventPpal -> setCursor( arrowCursor );
								ventPpal -> setCaption( "XRib - The Animation Software for Linux" );
						}
						else
						{
				  		ventPpal -> setCursor( waitCursor );
				  		ventPpal -> setCaption( "Procesing Rendering ... Please Wait" );
							sprintf(tempCad, "rendrib -samples %d %d -frames %d %d %s ./XRibSwap.tmp", xsamplesRIB, ysamplesRIB,this->ventPpal->frame_number->value(),this->ventPpal->frame_number->value(), cadena );				
							system( tempCad );
							ventPpal -> setCursor( arrowCursor );
							ventPpal -> setCaption( "XRib - The Animation Software for Linux" );
						}		
            this->view_foto();
       		break;
             		
				case 1 :	// grabar AVI video
					for (uint i = frameIniRIB; i<= frameFinRIB ; i++ )
					{
						exec_cad->truncate(0);
						exec_cad->sprintf("echo \"Display \\\"%s%d.tiff\\\" \\\"file\\\" \\\"rgba\\\"\" > XRibSwap.tmp ",fileRIB->latin1(),i+10000);
						system(exec_cad->latin1());
						exec_cad->truncate(0);
						exec_cad->sprintf("cat XRibSwap.dat >> XRibSwap.tmp ");
						system(exec_cad->latin1());		

						exec_cad->truncate(0);				
						ventPpal -> setCursor( waitCursor );
						ventPpal -> setCaption( "Procesing Rendering ... Please Wait" );
						exec_cad->sprintf("rendrib -samples %d %d %s -frames %d %d ./XRibSwap.tmp", xsamplesRIB, ysamplesRIB, cadena,i,i );
						system(exec_cad->latin1());
						ventPpal -> setCursor( arrowCursor );
						ventPpal -> setCaption( "XRib - The Animation Software for Linux" );
					}
					ofstream * parMPEG;

	        parMPEG = new ofstream( "./parMPEG" );

					exec_cad->truncate(0);
					exec_cad->append( *fileRIB );
					exec_cad->truncate( exec_cad->findRev ( "/" ) + 1);

					*parMPEG << "PATTERN I" << endl
									 <<  "OUTPUT " << fileRIB->latin1() << ".mpeg"  << endl
									 <<  "INPUT_DIR " << *exec_cad << endl
									 <<  "INPUT" << endl;

					exec_cad->truncate(0);
					exec_cad->append( *fileRIB );
					exec_cad->remove( 0 , exec_cad->findRev ( "/" ) + 1 ); // + 1

					*parMPEG << *exec_cad << "*.tiff [" << frameIniRIB+10000 << "-" << frameFinRIB+10000 << "]" << endl
									 << "END_INPUT" << endl
									 << "BASE_FILE_FORMAT PPM"   << endl
									 << "INPUT_CONVERT tifftopnm *"  << endl
									 << "GOP_SIZE 12"  << endl
									 << "PIXEL FULL"  << endl
									 << "PQSCALE 1"  << endl
									 << "RANGE 1"  << endl
									 << "PSEARCH_ALG EXHAUSTIVE"  << endl
									 << "IQSCALE 1"  << endl
									 << "BQSCALE 1"  << endl
									 << "SLICES_PER_FRAME 3"  << endl
									 << "BSEARCH_ALG EXHAUSTIVE"  << endl
									 << "REFERENCE_FRAME ORIGINAL"  << endl;
					
          parMPEG->close();
       		ventPpal -> setCursor( waitCursor );
       		ventPpal -> setCaption( "Creating MPEG-1 File ... Please Wait" );
					system("ppmtompeg -realquiet parMPEG ");
					ventPpal -> setCursor( arrowCursor );
					ventPpal -> setCaption( "XRib - The Animation Software for Linux" );

          exec_cad->truncate(0);				
				 	exec_cad->sprintf("rm -f %s*.tiff", fileRIB->latin1() );
		 			ventPpal -> setCursor( waitCursor );
		 			ventPpal -> setCaption( "Deleting Temporary Files ... Please Wait" );
					system(exec_cad->latin1());		
					ventPpal -> setCursor( arrowCursor );
					ventPpal -> setCaption( "XRib - The Animation Software for Linux" );

					this->view_foto();				  		

       		break;
              		
				case 2 :	// grabar Secuencia de tiff
					for (uint i = frameIniRIB; i<= frameFinRIB ; i++ )
					{
						exec_cad->truncate(0);
						exec_cad->sprintf("echo \"Display \\\"%s%d.tiff\\\" \\\"file\\\" \\\"rgba\\\"\" > XRibSwap.tmp ",fileRIB->latin1(),i+10000);
						system(exec_cad->latin1());
						exec_cad->truncate(0);
						exec_cad->sprintf("cat XRibSwap.dat >> XRibSwap.tmp ");
						system(exec_cad->latin1());		

						exec_cad->truncate(0);				
						ventPpal -> setCursor( waitCursor );
						ventPpal -> setCaption( "Procesing Rendering ... Please Wait" );
						exec_cad->sprintf("rendrib -samples %d %d %s -frames %d %d ./XRibSwap.tmp", xsamplesRIB, ysamplesRIB, cadena,i,i );
						system(exec_cad->latin1());	
						ventPpal -> setCursor( arrowCursor );
						ventPpal -> setCaption( "XRib - The Animation Software for Linux" );
       		}
          this->view_foto();
     		break;             				
			}
			delete exec_cad;		
		}
		else
		{
   		ventPpal -> setCursor( waitCursor );
   		ventPpal -> setCaption( "Procesing Rendering ... Please Wait" );
		  sprintf( tempCad, "rendrib -d %d -samples %d %d %s ./XRibSwap.dat &", scanlinesRIB, xsamplesRIB, ysamplesRIB, cadena );
		  system( tempCad );
		  ventPpal -> setCursor( arrowCursor );
		  ventPpal -> setCaption( "XRib - The Animation Software for Linux" );
		}
  }
}

void control :: generarArchivo( void )
{
  ( * salidaRIB ) << "Format " << anchoRIB << " " << altoRIB << " -1.0" << endl;
  ( * salidaRIB ) << "Projection \"perspective\" \"fov\" " << fovD << endl;
  ( * salidaRIB ) << "PixelSamples " << xsamplesRIB << " " << ysamplesRIB << endl;
  ( * salidaRIB ) << "ShadingRate 1" << endl;

  animAct = frameIniRIB;
  animando = true;
  emit _genRIBFrame( animAct );
}

void control :: view_foto( void )
{
	if ( saveRIB && !fileRIB->isEmpty()  )
	{
		QString *cadena;
	  cadena = new QString( );		

    switch ( dialRen->save_settings-> id( dialRen->save_settings -> selected( ) ) )
    {
			case 0:

				cadena->truncate(0);
				cadena->append("iv ");
				cadena->append(* fileRIB);
 				cadena->append(".tiff");
    		system ( cadena->latin1() );
				
				break;

			case 1:

				cadena->truncate(0);
				cadena->sprintf("plaympeg --loop %s.mpeg &",fileRIB->latin1() );
       	system(cadena->latin1());

				break;

			case 2:

    	 	QString *temp;
 			 	temp = new QString( );

				cadena->truncate(0);
				cadena->append("iv ");

			
				for (uint i=frameIniRIB+10000;i<=frameFinRIB+10000;i++)
				{
					temp->sprintf(" %s%d.tiff ",fileRIB->latin1(),i);    	
					cadena->append(*temp);
				}

   		  system ( cadena->latin1() );

				delete temp;
			break;
  	}
		delete cadena;
  }
	else
  	QMessageBox::information(0, "Warning", "There is not preview render file !");     	    	
}

void control :: abrir_escena( void )
{

	QString *fp, *tempo;
	int a, b, c;
	float d, e, f, g, h ,i, j, k, l, m, n, o, p, q, r, s;
	uint num;

    fp = new QString();
//   	tempo = new QString();

		*fp = QFileDialog::getOpenFileName( "","XRib Files ( *.xrib ) ", 0)  ;

    if ( !(fp->isNull()) )
    {
 			QFile F(*fp);

	  	if ( F.open(IO_ReadOnly) )
	  	{

        QTextStream t( &F );
        *fp = t.readLine();

	    	if(*fp != "XRib")	
				{
				  QMessageBox::information( 0, "XRib","This doesn't look like a XRib file.\n\nCheck and try again." );
				}
				else
				{
					nueva_escena();

		      ventPpal -> setCursor( waitCursor );
					ventPpal -> setCaption( "Loading File ... Please Wait" );

					*fp = t.readLine();
		
					if(*fp == "PRIMITIVAS")	
					{
            while ( !t.eof() )
            {
		   		 		*fp = t.readLine();
		   				if(*fp == "BOX")
		   				{
		       		  *fp = t.readLine();
	     				  tempo = new QString();	       		
		       		  if(*fp == "MATERIAL")
		     				{
//		     				  delete tempo;
		     				  *tempo = t.readLine();
		     				  tempo -> append("\n");
		     				  tempo -> append( t.readLine() );
		     				  tempo -> append("\n");
//		     				  tempo = new QString();
		     				  *fp = t.readLine();
		     				}
/*		     				else
		     				{
		     				  *fp = *tempo;
		     				  *tempo = "";
		     				}*/
		     				t >> a >> b >> c >> d >> e >> f >> g >> h >> i;
		     				t.readLine();
	  						tempC = new QString();
		  		
								tempP = ( primitiva * ) new primPrisma( this, fp -> latin1(), 100, (prim -> count() + 1)*2 + 2, tempC, new QColor( a, b, c ), d, e, f, g, h, i, tempo );
		   				}
		   				else
		     			if(*fp == "SPHERE")
		     			{
		       		  *fp = t.readLine();
	     				  tempo = new QString();	       		
		       		  if(*fp == "MATERIAL")
		     				{
//		     				  delete tempo;
//		     				  tempo = new QString();
		     				  *tempo = t.readLine();
		     				  tempo -> append("\n");
		     				  tempo -> append( t.readLine() );
		     				  tempo -> append("\n");
//		     				  tempo = new QString();
		     				  *fp = t.readLine();
		     				}
/*		     				else
		     				{
		     				  *fp = *tempo;
		     				  *tempo = "";
		     				}*/
		     				t >> a >> b >> c >> d >> e >> f >> g;
		     				t.readLine();
		  					tempC = new QString();
		  		
								tempP = ( primitiva * ) new primEsfera( this, fp -> latin1(), 100, (prim -> count() + 1)*2 + 2, tempC, new QColor( a, b, c ), d, e, f, g, tempo );
		     			}
		     			else
		       		if(*fp == "CONE")
		       		{
		       		  *fp = t.readLine();
	     				  tempo = new QString();	       		
		       		  if(*fp == "MATERIAL")
		     				{
//		     				  delete tempo;
//		     				  tempo = new QString();
		     				  *tempo = t.readLine();
		     				  tempo -> append("\n");
		     				  tempo -> append( t.readLine() );
		     				  tempo -> append("\n");
//		     				  tempo = new QString();
		     				  *fp = t.readLine();
		     				}
	/*	     				else
		     				{
		     				  *fp = *tempo;
		     				  *tempo = "";
		     				}                               */
		     				t >> a >> b >> c >> d >> e >> f;
		     				t.readLine();
		            tempC = new QString();
		  		
								tempP = ( primitiva * ) new primCono( this, fp -> latin1(), 100, (prim -> count() + 1)*2 + 2, tempC, new QColor( a, b, c ), d, e, f, tempo );
		       		}
		       		else
		     	 		if(*fp == "CYLINDER")
		     	 		{
		       		  *fp = t.readLine();
	     				  tempo = new QString();	       		
		       		  if(*fp == "MATERIAL")
		     				{
//		     				  delete tempo;
//		     				  tempo = new QString();
		     				  *tempo = t.readLine();
		     				  tempo -> append("\n");
		     				  tempo -> append( t.readLine() );
		     				  tempo -> append("\n");
//		     				  tempo = new QString();
		     				  *fp = t.readLine();
		     				}
/*		     				else
		     				{
		     				  *fp = *tempo;
		     				  *tempo = "";
		     				}*/
		     				t >> a >> b >> c >> d >> e >> f >> g;
		     				t.readLine();
							  tempC = new QString();
		  		
								tempP = ( primitiva * ) new primCilindro( this, fp -> latin1(), 100, (prim -> count() + 1)*2 + 2, tempC, new QColor( a, b, c ), d, e, f, g, tempo );
		     	 		}
		     	 		else
		     			if(*fp == "DISK")
		     			{
		       		  *fp = t.readLine();
	     				  tempo = new QString();	       		
		       		  if(*tempo == "MATERIAL")
		     				{
//		     				  delete tempo;
//		     				  tempo = new QString();
		     				  *tempo = t.readLine();
		     				  tempo -> append("\n");
		     				  tempo -> append( t.readLine() );
		     				  tempo -> append("\n");
//		     				  tempo = new QString();
		     				  *fp = t.readLine();
		     				}
	/*	     				else
		     				{
		     				  *fp = *tempo;
		     				  *tempo = "";
		     				}*/
		     				t >> a >> b >> c >> d >> e >> f;
		     				t.readLine();
		  					tempC = new QString();
		  		
								tempP = ( primitiva * ) new primDisco( this, fp -> latin1(), 100, (prim -> count() + 1)*2 + 2, tempC, new QColor( a, b, c ), d, e, f, tempo );
		     			}
		     			else
		     		  if(*fp == "TORUS")
		     		  {
		       		  *fp = t.readLine();
	     				  tempo = new QString();	       		
		       		  if(*fp == "MATERIAL")
		     				{
//		     				  delete tempo;
//		     				  tempo = new QString();
		     				  *tempo = t.readLine();
		     				  tempo -> append("\n");
		     				  tempo -> append( t.readLine() );
		     				  tempo -> append("\n");
//		     				  tempo = new QString();
		     				  *fp = t.readLine();
		     				}
		     				/*else
		     				{
		     				  *fp = *tempo;
		     				  *tempo = "";
		     				} */
		     				t >> a >> b >> c >> d >> e >> f >> g >> h;
		     				t.readLine();
		  					tempC = new QString();
		  		
								tempP = ( primitiva * ) new primToro( this, fp -> latin1(), 100, (prim -> count() + 1)*2 + 2, tempC, new QColor( a, b, c ), d, e, f, g, h, tempo );
		     		  }
		     		  else
		     			if(*fp == "HYPERBOLOID")
		     			{
		       		  *fp = t.readLine();
	     				  tempo = new QString();	       		
		       		  if(*fp == "MATERIAL")
		     				{
//		     				  tempo = new QString();
		     				  *tempo = t.readLine();
		     				  tempo -> append("\n");
		     				  tempo -> append( t.readLine() );
		     				  tempo -> append("\n");
//		     				  tempo = new QString();
		     				  *fp = t.readLine();
		     				}
	/*	     				else
		     				{
		     				  *fp = *tempo;
		     				  *tempo = "";
		     				}*/
		     				t >> a >> b >> c >> d >> e >> f >> g >> h >> i >> j;
		     				t.readLine();
		  					tempC = new QString();
		  		
								tempP = ( primitiva * ) new primHyper( this, fp -> latin1(), 100, (prim -> count() + 1)*2 + 2, tempC, new QColor( a, b, c ), d, e, f, g, h, i, j, tempo );
		     			}
		     			else
		     			  break;
		     					     			
		     			connect( this, SIGNAL( _generarInterCreac( void ) ), tempP, SLOT( generarInterCreac( void ) ) );
							connect( tempP, SIGNAL( _objetoCreado( void ) ), this, SLOT( primCreada( void ) ) );
							connect( tempP, SIGNAL( _objetoNoCreado( void ) ), this, SLOT( primNoCreada( void ) ) );
							connect( this, SIGNAL( _actualizarRIB( void ) ), tempP, SLOT( generarCodRIB( void ) ) );
							connect( this, SIGNAL( _actualizarGL( void ) ), tempP, SLOT( generarCodGL( void ) ) );
							connect( tempP, SIGNAL( _actualizacionPrimOK( void ) ), this, SLOT( actualizarPrims( void ) ) );
						  connect( tempP, SIGNAL( _actualizarValor( void ) ), this, SIGNAL( _actualizarGL( void ) ) );
						  connect( this, SIGNAL( _cambiarAFrame( int ) ), tempP, SLOT( cambiarAFrame( int ) ) );
						  connect( this, SIGNAL( _material( QString * ) ), tempP, SLOT( material( QString * ) ) );
							connect( tempP, SIGNAL( _nombre( QString ) ), this, SLOT( addLista( QString ) ) );
						  connect( this, SIGNAL( _getNombres( void ) ), tempP, SLOT( getNombre( void ) ) );
							connect( this, SIGNAL( _seleccionar( QString, bool ) ), tempP, SLOT( seleccionar( QString, bool ) ) );
							connect( tempP, SIGNAL( _revisarNombre( const QString & ) ), this, SLOT( revisarNombre( const QString & ) ) );
						  connect( this, SIGNAL( _getNombresValidar( void ) ), tempP, SLOT( validarNombre( void ) ) );
							connect( tempP, SIGNAL( _validarNombre( QString ) ), this, SLOT( validarNombres( QString ) ) );
							connect( this, SIGNAL( _record( void ) ), tempP, SLOT( record( void ) ) );
							connect( this, SIGNAL( _record( Matrix, QString *, uint ) ), tempP, SLOT( addTransf( Matrix, QString *, uint ) ) );
						  connect( this, SIGNAL( _resetPreview( void ) ), tempP, SLOT( resetPreview( void ) ) );
							connect( this, SIGNAL( _moverPreview( Matrix ) ), tempP, SLOT( addPreview( Matrix ) ) );
							connect( this, SIGNAL( _moverTransf( Matrix ) ), tempP, SLOT( addTransf( Matrix ) ) );
							connect( this, SIGNAL( _rotarPreview( Matrix ) ), tempP, SLOT( addPreview( Matrix ) ) );
						  connect( this, SIGNAL( _interpolar( void ) ), tempP, SLOT( interpolar( void ) ) );
						  connect( tempP, SIGNAL( _interpolarFin( void ) ), this, SLOT( interpolarFin( void ) ) );
							connect( this, SIGNAL( _rotarTransf( Matrix ) ), tempP, SLOT( addTransf( Matrix ) ) );
							connect( this, SIGNAL( _escalarPreview( Matrix ) ), tempP, SLOT( addPreview( Matrix ) ) );
							connect( this, SIGNAL( _escalarTransf( Matrix ) ), tempP, SLOT( addTransf( Matrix ) ) );
							connect( this, SIGNAL( _recortePreview( Matrix ) ), tempP, SLOT( addPreview( Matrix ) ) );
							connect( this, SIGNAL( _recorteTransf( Matrix ) ), tempP, SLOT( addTransf( Matrix ) ) );
							connect( this, SIGNAL( _mirrorPreview( Matrix ) ), tempP, SLOT( addPreview( Matrix ) ) );
							connect( this, SIGNAL( _mirrorTransf( Matrix ) ), tempP, SLOT( addTransf( Matrix ) ) );
				  		connect( this, SIGNAL( _genRIBFrame( uint ) ), tempP, SLOT( genRIBFrame( uint ) ) );
							connect( tempP, SIGNAL( _animOk( void ) ), this, SLOT( animar( void ) ) );
							connect( this, SIGNAL( _obtFramesXRib( void ) ), tempP, SLOT( genFrameXRib( void ) ) );	
							connect( this, SIGNAL( _obtEncabezadoXRib( void ) ), tempP, SLOT( encabezadoXRIB( void ) ) );	
				      connect( tempP, SIGNAL( _frameOK( void ) ), this, SLOT( ensamblarXRIB( void ) ));
							connect( tempP, SIGNAL( _finXRIB( void ) ), this, SLOT( generarXRIB( void ) ));
							connect( tempP, SIGNAL( _encabezadoOK( void ) ), this, SLOT( genEncabezadoRIB( void ) ));
		     			
		     			if( prim -> count() == prim -> size())
							{
							  prim -> resize( prim -> size() + 5 );
							}
	
						  prim -> insert( prim -> count(), tempP );

						  tempP = 0;
	
							if( cadsR -> count() == cadsR -> size())
							{
							  cadsR -> resize( cadsR -> size() + 5 );
							}
	
						  cadsR -> insert( cadsR -> count(), tempC );

  						tempC = 0;

		     		}
					}
		
					if(*fp == "LUCES")	
					{
          	while ( !t.eof() )
          	{
		   				*fp = t.readLine();
		   				if(*fp == "AMBIENT")
		   				{	
		     				t >> d >> e >> f >> g;
		     				emit _dialogo_crear_ambiental( d, e, f, g );
		     				*fp = t.readLine();
		   				}
		   				else
		     			if(*fp == "OMNI")
		     			{
		     				t >> d >> e >> f >> g >> h >> i >> j;
		     				emit _dialogo_crear_omni( d, e, f, g, h, i, j );
		     				*fp = t.readLine();
		     			}
		     			else
		       		if(*fp == "SPOT")
		       		{
		     				t >> d >> e >> f >> g >> h >> i >> j >> k >> l >> m >> n >> o >> p;
								emit _dialogo_crear_spot( d, e, f, g, h, i, j, k, l, m, n, o, p );
		     				*fp = t.readLine();
		       		}
		       		else
		         		break;
						}		
					}
					while ( !t.eof() )
					{
          	if( *fp == "" )
          	{
          	  break;
          	}
          	if(*fp == "FRAME")
          	{
	   					t >> num;		
	   					*fp = t.readLine();
		    		}
		    		else
		    		if(*fp == "CAMARA")
		  			{
		    				t >> d >> e >> f >> g >> h >> i;
		    				emit _record( num, d, e, f, g, h, i );
		     				*fp = t.readLine();
		   			}
		   			else
		     		{
		     			Matrix *tempMa;
		     				
		     			tempMa = new Matrix( 4, 4 );
		     			t >> d >> e >> f >> g >> h >> i >> j >> k >> l >> m >> n >> o >> p >> q >> r >> s;
		     			(*tempMa)( 0, 0 ) = d;
		     			(*tempMa)( 1, 0 ) = e;
		     			(*tempMa)( 2, 0 ) = f;
		     			(*tempMa)( 3, 0 ) =	g;
		   				(*tempMa)( 0, 1 ) = h;
		   				(*tempMa)( 1, 1 ) = i;
		   				(*tempMa)( 2, 1 ) = j;
		   				(*tempMa)( 3, 1 ) =	k;
		   				(*tempMa)( 0, 2 ) = l;
		    			(*tempMa)( 1, 2 ) = m;
		    			(*tempMa)( 2, 2 ) = n;
		    			(*tempMa)( 3, 2 ) =	o;
		    			(*tempMa)( 0, 3 ) = p;
		    			(*tempMa)( 1, 3 ) = q;
		    			(*tempMa)( 2, 3 ) = r;
		    			(*tempMa)( 3, 3 ) =	s;     						     						     				
		    			emit _record( *tempMa, fp, num );
		    			*fp = t.readLine();
		    		}
		    		*fp = t.readLine();					
					}
        }
      	ventPpal -> setCursor( arrowCursor );
				ventPpal -> setCaption( "XRib - The Animation Software for Linux" );
      	F.close();
    		delete fp;
    	}	
  	}
  	this->ventPpal->frame_number->setValue( 0 );
  	emit _actualizarGL( );
}
	
void control :: nueva_escena( void )
{
	switch( QMessageBox::information( 0, "XRib - The Animation Software for Linux","The document contains unsaved work\nDo you want to save it before creating the new scene?", "&Save", "&Don't Save", 0,1 ) )
	{
    case 0:
        this -> guardar_escena( );
        break;
  }

		glDeleteLists( 3, prim -> count() * 2 + 21 );
	
		for( uint i = 0; i < prim -> count(); ++i )
		{
		  tempP = prim -> at( i );
		  delete tempP;
		}

		for( uint i = 0; i < cadsR -> count(); ++i )
		{
		  tempC = cadsR -> at( i );
		  delete tempC;
		}
	
	
	  delete world;
		delete prim;
  	delete cadsR;
	  delete lista;
  	delete dialRen;
	  delete dialRenGL;
	  delete luz;
	
		ultKeyFrameN = 0;
		prim = new VectorP( );
		cadsR = new VectorC( );
		primOK = 0;
		nombOK = 0;
		RIBOk = 0;
		animando = false;
		salvando = false;
		tempC = new QString( );
		luz = new QString();
		world = new mundo( this, "Mundo", tempC, luz );
		lista = new QStringList( );
		matT -> Unit( );
		cadsR -> resize( 5 );
		cadsR -> insert( cadsR -> count(), tempC );
  	tempC = 0;
		dialRen = new dialogo_render_imp( 0, "" );
  	dialRenGL = new dialogo_rendergl( 0, "", true );

		anchoRIB = 640;
		altoRIB = 480;
		frameIniRIB = 0;
		frameFinRIB = 100;
		fpsRIB = 30;
		detailRIB = 1.0;
		cerrarRIB = false;
		estiloRIB = 0;
	
		xsamplesRIB = 1;
		ysamplesRIB = 1;
		scanlinesRIB = 1;
	
		cropRIB = false;
		xMinCropRIB = 0.0;
		yMinCropRIB = 0.0;
		xMaxCropRIB = 1.0;
		yMaxCropRIB = 1.0;
	
		radRIB = false;
		radStepsRIB = 1;
		radSamplesRIB = 2;
		
		saveRIB = false;
	
		connect( this, SIGNAL( _camera_edit( void ) ), world, SIGNAL( _camera_edit( void ) ) );
		connect( this, SIGNAL( _cambiarAFrame( int ) ), world, SIGNAL( _cambiarAFrame( int ) ) );
		connect( this, SIGNAL( _actualizarGL( void ) ), world, SIGNAL( _actualizarGL( void ) ) );
		connect( this, SIGNAL( _record( void ) ), world, SIGNAL( _record( void ) ) );
		connect(this, SIGNAL( _record( uint, float, float, float, float, float, float ) ), world, SIGNAL( _record( uint, float, float, float, float, float, float ) ) );	
		connect( this, SIGNAL( _actualizarRIB( void ) ), world, SLOT( generarCodRIB( void ) ) );
		connect( world, SIGNAL( _animOk( void ) ), this, SLOT( animar( void ) ) );
  	connect( this, SIGNAL( _genRIBFrame( uint ) ), world, SLOT( genRIBFrame( uint ) ) );
		connect( this, SIGNAL( _dialogo_crear_ambiental( void ) ), world, SLOT( addAmb( void ) ) );	
		connect( this, SIGNAL( _dialogo_crear_omni( void ) ), world, SLOT( addOmn( void ) ) );	
		connect( this, SIGNAL( _dialogo_crear_spot( void ) ), world, SLOT( addSpo( void ) ) );
		connect( this, SIGNAL( _dialogo_crear_ambiental( float, float, float, float ) ), world, SLOT( addAmb( float, float, float, float ) ) );	
		connect( this, SIGNAL( _dialogo_crear_omni( float, float, float, float, float, float, float ) ), world, SLOT( addOmn( float, float, float, float, float, float, float ) ) );	
		connect( this, SIGNAL( _dialogo_crear_spot( float, float, float, float, float, float, float, float, float, float, float, float, float ) ), world, SLOT( addSpo( float, float, float, float, float, float, float, float, float, float, float, float, float ) ) );	
	
		connect( this, SIGNAL( _obtFramesXRib( void ) ), world, SLOT( frameXRIB( void ) ) );	
		connect( this, SIGNAL( _obtEncabezadoXRib( void ) ), world, SLOT( encabezadoXRIB( void ) ) );	

	  this -> iniciar( );
   	this->ventPpal->frame_number->setValue( 0 );
}

void control :: generarXRIB( void )
{
  ++ensambOK;
  if( ensambOK == prim -> count() + 1 )
  {
  QString *fp;


  for( uint i = 0; i < cadsR -> count( ); ++i )
	    ( * salidaRIB ) << *( cadsR -> at( i ) );

	salidaRIB -> close( );
	
  fp = new QString();

  *fp = QFileDialog::getSaveFileName("NewFile.xrib","XRib Files ( *.xrib )", 0 );
  if ( !(fp->isNull()) )
  {
    cadEx -> sprintf( "cp XRibSwap.dat %s ; rm -f XRibSwap.dat", fp -> latin1() );
    system( cadEx -> latin1() );
  }
  ensambOK = 0;
  }
}

void control :: ensamblarXRIB( void )
{
  ++ensambOK;

  if( ensambOK == prim -> count() + 1 )
  {

    for( uint i = 0; i < cadsR -> count( ); ++i )
	    ( * salidaRIB ) << *( cadsR -> at( i ) );
	  ensambOK = 0;
    emit _obtFramesXRib( );
  }
}

void control :: genEncabezadoRIB( void )
{
  ++encabOK;

  if( encabOK == prim -> count() + 1 )
  {
    ( * salidaRIB ) << "XRib\n";
    ( * salidaRIB ) << "PRIMITIVAS";
    for( uint i = 1; i < cadsR -> count( ); ++i )
	    ( * salidaRIB ) << *( cadsR -> at( i ) );
	  ( * salidaRIB ) << *( cadsR -> at( 0 ) );
	  encabOK = 0;
    emit _obtFramesXRib( );
  }
}

void control :: guardar_escena( void )
{
  salidaRIB = new ofstream( "./XRibSwap.dat" );
  encabOK = 0;
  ensambOK = 0;
  emit _obtEncabezadoXRib( );
}

void control :: guardar_escena_rib( void )
{
  QString *fp;

  salidaRIB = new ofstream( "./XRibSwap.dat" );

  fp = new QString();

  *fp = QFileDialog::getSaveFileName("NewFile.rib","Rib Files ( *.rib )", 0 );
  if ( !(fp->isNull()) )
  {
  	salvando = true;

	  anchoRIB = 640;
  	altoRIB = 480;
	  xsamplesRIB = 1;
  	ysamplesRIB = 1;
	  frameIniRIB = 0;
  	frameFinRIB = ultKeyFrameN;

	  cadEx -> sprintf( "cp XRibSwap.dat %s ; rm -f XRibSwap.dat", fp -> latin1() );
		this -> actualizarRIB( );
  }
}

void control :: salvarArchivo ( void )
{
  system( cadEx -> latin1() );
}

void control :: interpolar( void )
{
  ventPpal -> setCursor( waitCursor );
	ventPpal -> setCaption( "Interpolating ... Please Wait" );
  emit _interpolar( );
}

void control :: interpolarFin( void )
{
  ++interp;

  if( interp == prim -> count() + 1 )
  {
  	ventPpal -> setCursor( arrowCursor );
		ventPpal -> setCaption( "XRib - The Animation Software for Linux" );
		this->ventPpal->frame_number->setValue( 0 );
		interp = 0;
		cout << "termino de interpolar" << endl;
	}
}
