/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 #ifndef DEFINES_H
 #define DEFINES_H

  #define _NO_EXCEPTION

  #include <colorform.h>
  #include <fstream.h>
	#include <iostream.h>
  #include <matrix.h>
	#include <qapplication.h>
	#include <qbuttongroup.h>
  #include <qcheckbox.h>
  #include <qcolor.h>
  #include <qcolordialog.h>
  #include <qfiledialog.h>
  #include <qfont.h>
  #include <qgl.h>
	#include <qlayout.h>
	#include <qlineedit.h>
  #include <qlist.h>
	#include <qlistbox.h>
	#include <qmessagebox.h>
  #include <qobject.h>
  #include <qpushbutton.h>
  #include <qrect.h>
  #include <qslider.h>
  #include <qstring.h>
  #include <qstringlist.h>
  #include <qtabwidget.h>
  #include <qtextcodec.h>
  #include <qtextstream.h>
  #include <qtimer.h>
  #include <qtranslator.h>
  #include <qvector.h>
  #include <qwidget.h>
  #include <stdlib.h>
  #include <ventana.h>

	#ifndef _NO_NAMESPACE
		using namespace std;
		using namespace math;
		#define STD std
	#else
		#define STD
	#endif

	typedef matrix<GLfloat> Matrix;
	typedef Matrix * pMatrix;


 	// Scene
 	#define NEW 1
 	#define OPEN 2
 	#define SAVE  3
 	#define SAVE_AS 4
 	#define CLOSE 5

 	// Objects
 	#define BOX 6
 	#define SPHERE 7
 	#define CONE 8
 	#define CYLINDER 9
 	#define DISK 10
 	#define HYPERBOLOID 11
 	#define TORUS 12
 	#define TUBE 13

 	// Lights
 	#define AMBIENT 14
 	#define OMNI 15
 	#define SPOT 16

 	// Camera
 	#define CAMERA_SETTINGS 17

 	// Modifiers
 	#define SELECT 19
 	#define SELECT_BY_NAME 20
 	#define MOVE 21
 	#define ROTATE 22
 	#define UNIFORM_SCALE 23
 	#define PROPORTION_SCALE 24
 	#define NON_PROPORTION_SCALE 25
 	#define SKEW 26
 	#define TEXTURE 27

 	// Animation
 	#define TIMELINE 28

 	// Render
 	#define RENDER 29
 	#define PREVIEW 30

	// Camaras Standard
 	#define TOP 31
 	#define LEFT 32
 	#define RIGHT 33
 	#define BACK 34
 	#define BOTTOM 35
 	#define FRONT 36
 	#define CAMERA 37
  #define ABOUT 38
 	// Image Defaults
 	#define FILENAME "xrib.tiff"
 	#define DATATYPE RI_RGBA
 	#define PICXRES 640
 	#define PICYRES 480

 	#define CROPMINX 0.0
 	#define CROPMAXX 1.0
	#define CROPMINY 0.0
 	#define CROPMAXY 1.0

	#define CAMXFROM 10.0
	#define CAMYFROM 0.0
	#define CAMZFROM 10.0

	#define CAMXTO 0.0
	#define CAMYTO 0.0
	#define CAMZTO 0.0
	
	#define CAMROLL 0.0
	#define CAMZOOM 1.0

	#define OPTSPHER 10
	#define OPTHYPER 40
	#define OPTTORUS 20
	
	class primitiva;
	
	typedef QVector<primitiva> VectorP;
	typedef QVector<QString> VectorC;
	
	#endif
