/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "glApplet.h"

glApplet :: glApplet( QWidget* parent, const char* name,  const QGLWidget*  shareWidget  )
					: QGLWidget( parent, name,  shareWidget )
{
	reaccion = 0;
}

glApplet :: ~glApplet()
{
}

void glApplet :: initializeGL()
{
    left = -10.0;
    right = 10.0;
    top = 10.0;
    bottom = -10.0;
    near = 1.0;
    far = 1000.0;
    fov = 60.0;
    zoom = 1.0;
    anchoW = 310;
    altoW = 170;
    aspect = altoW / anchoW;
		color = new QColor( 128, 128, 128 );
		camaraGL = 1;

    glClearColor( (GLfloat)(color -> red( ))/255.0, (GLfloat)(color -> green( ))/255.0, (GLfloat)(color -> blue( ))/255.0, 0.0 );

    glEnable(GL_DEPTH_TEST);

    glViewport( 0, 0, (GLint)anchoW, (GLint)altoW );

}

void glApplet :: paintGL()
{
	makeCurrent();
	
  if( !modoV )
	{
		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
   	glShadeModel( GL_FLAT );
	}
	else
	{
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
    glShadeModel( GL_SMOOTH );
	}

	switch( camaraGL )
  {
    case 1:
		  glMatrixMode( GL_PROJECTION );
		  glLoadIdentity();
    	gluPerspective(fov*zoom, aspect, near, far);
    	break;
    default:
		  glMatrixMode( GL_PROJECTION );
		  glLoadIdentity();
  	  if ( aspect < 1.0 )
    		glOrtho(left*zoom, right*zoom, bottom*zoom / aspect, top*zoom / aspect, near, far);
			else
    		glOrtho(left*zoom*aspect, right*zoom*aspect, bottom*zoom, top*zoom, near, far);
    	break;
	}

  switch( camaraGL )
  {
  /* Top */
  	case 3:
			glNewList( 3, GL_COMPILE );
	    	gluLookAt(0.0, 50.0*zoom, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.0);
  		glEndList();
			break;

  /* Left */
  	case 5:
			glNewList( 5, GL_COMPILE );
	    	gluLookAt(-50.0*zoom, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
  		glEndList();
      break;

  /* Front */
  	case 7:
			glNewList( 7, GL_COMPILE );
    		gluLookAt(0.0, 0.0, 50.0*zoom, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
		  glEndList();
    	break;

  /* Bottom */
  	case 9:
			glNewList( 9, GL_COMPILE );
    		gluLookAt(0.0, -50.0*zoom, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0);
		  glEndList();
			break;

  /* Right */
  	case 11:
			glNewList( 11, GL_COMPILE );
    		gluLookAt(50.0*zoom, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
		  glEndList();
			break;

  /* Back */
  	case 13:
			glNewList( 13, GL_COMPILE );
    		gluLookAt(0.0, 0.0, -50.0*zoom, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
		  glEndList();
		  break;
  }

  glMatrixMode( GL_MODELVIEW );

  glLoadIdentity();

  glClearColor( (GLfloat)(color -> red( ))/255.0, (GLfloat)(color -> green( ))/255.0, (GLfloat)(color -> blue( ))/255.0, 0.0 );

	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
  	
  glCallList( camaraGL );
/*  if( camaraGL == 1 )
  {
	  glColor3f( 0.4, 0.4, 0.4 );
  // Creamos la malla.
  	for(int i = -1000; i < 1000; i += 10)
//    for(h = -1000; h < 1000; ++h)
	  {
      if( i % 20 == 0 )
        glLineWidth( 2 );
      else
        glLineWidth( 0.5 );
      if( i == 0 )
        glLineWidth( 3 );
	  	glBegin( GL_LINES );
    	  glVertex3i( i, 0, 1000 );
  	    glVertex3i( i, 0, -1000 );
    	  glVertex3i( -1000, 0, i );
	     	glVertex3i( 1000, 0, i );
  		glEnd();
    }
  	glLineWidth( 1 );
  }*/
  glCallList( 2 );

  glCallList( 21 );
	
	glFinish();
}

void glApplet :: actualizarDatos( GLuint camaraGLN, GLdouble nearN, GLdouble farN, GLdouble fovN, GLdouble zoomN, QColor colorN, bool modoVN )
{
  altoW = this -> geometry( ) . height( );
  anchoW = this -> geometry( ) . width( );
  glViewport( 0, 0, (GLint)anchoW, (GLint)altoW );
	near =	nearN;
	far = farN;
	fov = fovN;
	zoom =	zoomN;
	color -> setRgb( colorN . rgb( ) );
	modoV = modoVN;
	camaraGL = camaraGLN;
  aspect = anchoW / altoW;
  emit _fov( fov );

	updateGL();
}

void glApplet :: resizeGL( int w, int h )
{
  altoW = h;
  anchoW = w;
  emit _actualizarDatos( );
}

void glApplet :: cambiarModoVisual( int _modoV )
{
	if ( _modoV > 0 )
  {
  	modoV = true;
  }
  else
		if( _modoV == 0 )
	  { 	
  	  modoV = false;
	  }
		else
			if( modoV )
			{
				modoV = false;
			}
			else
			{
				modoV = true;
			}
}

void glApplet :: pintarLista( void )
{
	emit _actualizarDatos( );
}
