/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


/* 	glApplet, es el manejador de ms bajo nivel de las ventanas openGL.
		Sin embargo, su funcionamiento es sencillo, limitandose a desplegar la
		lista de comandos que le es proveda.
*/

#ifndef GLAPPLET_H
#define GLAPPLET_H

#include "defines.h"

class glApplet : public QGLWidget
{
  Q_OBJECT

	public:

		glApplet( QWidget* parent, const char* name ,  const QGLWidget*  shareWidget = 0 );
	  ~glApplet();
	  GLuint camaraGL;
	
	

	public slots:

		/* 	pintarLista, le dice al objeto que debe desplegar la lista _lista.
				reaccionTocado, cambia el estado interno de como debe reaccionar el objeto
				cuando es tocado, de tal modo que si es 1 o true, pinta un pequeo punto
				en la coordenada donde ha sido tocado.
				haSidoTocado, le dice al objeto que el usuario le toco o hizo click en el
				punto indicado (esto, para sincronizacin).
		*/

		void cambiarModoVisual( int );
  	void pintarLista( void );
//    void setBaseGL( GLuint );
    void actualizarDatos( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool );
	
	protected:

    void initializeGL();
    void paintGL();
    void resizeGL( int w, int h );

	private:

		GLuint reaccion;
		GLuint modoV;
    GLdouble left, right, top, bottom, near, far, fov, zoom, aspect, anchoW, altoW;
		QColor *color;
		
	signals:

		void _actualizarDatos( void );
		void _fov( GLdouble );
		                                                          	
};
#endif
