/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "interfaz.h"

interfaz	:: interfaz( QObject *parent )
: ventana()
{
	QVBoxLayout * tab0Layout;
	QVBoxLayout * tab1Layout;
	QVBoxLayout * tab2Layout;
	QVBoxLayout * tab3Layout;

	dialogo_time = new dialogo_timeline( 0, "", true );
	
	bg0 ->  color_object . setRgb( 0, 0, 0 );
	bg1 ->  color_object . setRgb( 0, 0, 0 );
	bg2 ->  color_object . setRgb( 0, 0, 0 );
	bg3 ->  color_object . setRgb( 0, 0, 0 );
	
//	dialMat = new dialogo_material( 0, "", true );
		
	tab0 -> setCurrentPage( 0 );
	tab0Layout = new QVBoxLayout( tab0 -> currentPage( ) );
	tab0Layout -> setSpacing( 0 );
	tab0Layout -> setMargin( 0 );
	
	glApp0 = new glApplet( tab0 -> currentPage( ), "glApplet 0" );
	tab0Layout -> addWidget( glApp0 );
/**/
	tab1 -> setCurrentPage( 0 );
	tab1Layout = new QVBoxLayout( tab1 -> currentPage( ) );
	tab1Layout -> setSpacing( 0 );
	tab1Layout -> setMargin( 0 );
	
	glApp1 = new glApplet( tab1 -> currentPage( ), "glApplet 1", glApp0 );
	tab1Layout -> addWidget( glApp1 );
/**/
  tab2 -> setCurrentPage( 0 );
	tab2Layout = new QVBoxLayout( tab2 -> currentPage( ) );
	tab2Layout -> setSpacing( 0 );
	tab2Layout -> setMargin( 0 );
	
	glApp2 = new glApplet( tab2 -> currentPage( ), "glApplet 2", glApp1 );
	tab2Layout -> addWidget( glApp2 );
/**/	
  tab3 -> setCurrentPage( 0 );
	tab3Layout = new QVBoxLayout( tab3 -> currentPage( ) );
	tab3Layout -> setSpacing( 0 );
	tab3Layout -> setMargin( 0 );
	
	glApp3 = new glApplet( tab3 -> currentPage( ), "glApplet 3", glApp2 );
	tab3Layout -> addWidget( glApp3 );
		
	connect( this, SIGNAL( _dialogo_crear_ambiental( void ) ), parent, SIGNAL( _dialogo_crear_ambiental( void ) ) );	
	connect( this, SIGNAL( _dialogo_crear_omni( void ) ), parent, SIGNAL( _dialogo_crear_omni( void ) ) );	
	connect( this, SIGNAL( _dialogo_crear_spot( void ) ), parent, SIGNAL( _dialogo_crear_spot( void ) ) );	
  connect( this, SIGNAL( _dialogo_crear( int ) ), parent, SLOT( dialogo_crear( int ) ) );	
  connect( this, SIGNAL( _cambiarAFrame( int ) ), parent, SIGNAL( _cambiarAFrame( int ) ) );	
  connect( this, SIGNAL( _cambiarAFrame( int ) ), parent, SIGNAL( _actualizarGL( void ) ) );	
  connect( this, SIGNAL( _seleccionarPrims( void ) ), parent, SLOT( dialogoSeleccion( void ) ) );	
  connect( this, SIGNAL( _actBKColor( QColor * ) ), parent, SLOT( actBKColor( QColor * ) ) );	
	connect( parent, SIGNAL( _cambiarModoVisual( int, int ) ), this, SLOT( cambiarModoVisual( int, int ) ) );	
	connect( parent, SIGNAL( _cambiarCamara( int, int ) ), this, SLOT( cambiarCamara( int, int ) ) );	
  connect( this, SIGNAL( _record( void ) ), parent, SLOT( record( void ) ) );	
  connect( this, SIGNAL( _interpolar( void ) ), parent, SLOT( interpolar( void ) ) );	
	connect( parent, SIGNAL( _inicializar( void ) ), this, SLOT( actualizarDatosX( void ) ) );	
	connect( parent, SIGNAL( _inicializar( void ) ), this, SLOT( actualizarDatosY( void ) ) );	
	connect( parent, SIGNAL( _inicializar( void ) ), this, SLOT( actualizarDatosZ( void ) ) );	
	connect( parent, SIGNAL( _inicializar( void ) ), this, SLOT( actualizarDatosC( void ) ) );	
	
	connect( parent, SIGNAL( _rePaint( void ) ), ( QObject * ) glApp0, SLOT( pintarLista( void ) ));
	connect( parent, SIGNAL( _rePaint( void ) ), ( QObject * ) glApp1, SLOT( pintarLista( void ) ));
	connect( parent, SIGNAL( _rePaint( void ) ), ( QObject * ) glApp2, SLOT( pintarLista( void ) ));
	connect( parent, SIGNAL( _rePaint( void ) ), ( QObject * ) glApp3, SLOT( pintarLista( void ) ));
   /*
	connect( parent, SIGNAL( _baseGL( GLuint ) ), ( QObject * ) glApp0, SLOT( setBaseGL( GLuint ) ));
	connect( parent, SIGNAL( _baseGL( GLuint ) ), ( QObject * ) glApp1, SLOT( setBaseGL( GLuint ) ));
	connect( parent, SIGNAL( _baseGL( GLuint ) ), ( QObject * ) glApp2, SLOT( setBaseGL( GLuint ) ));
	connect( parent, SIGNAL( _baseGL( GLuint ) ), ( QObject * ) glApp3, SLOT( setBaseGL( GLuint ) ));
        */
	connect( this, SIGNAL( _actualizarDatosX( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool ) ), ( QObject * ) glApp0, SLOT( actualizarDatos( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool ) ));
	connect( this, SIGNAL( _actualizarDatosY( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool ) ), ( QObject * ) glApp1, SLOT( actualizarDatos( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool ) ));
	connect( this, SIGNAL( _actualizarDatosZ( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool ) ), ( QObject * ) glApp2, SLOT( actualizarDatos( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool ) ));
	connect( this, SIGNAL( _actualizarDatosC( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool ) ), ( QObject * ) glApp3, SLOT( actualizarDatos( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool ) ));
	
	connect( ( QObject * ) glApp3, SIGNAL( _fov( GLdouble ) ), parent, SLOT( fov( GLdouble ) ));
		
	connect( ( QObject * ) glApp0, SIGNAL( _actualizarDatos( void ) ), this, SLOT( actualizarDatosX( void ) ));
	connect( ( QObject * ) glApp1, SIGNAL( _actualizarDatos( void ) ), this, SLOT( actualizarDatosY( void ) ));
	connect( ( QObject * ) glApp2, SIGNAL( _actualizarDatos( void ) ), this, SLOT( actualizarDatosZ( void ) ));
	connect( ( QObject * ) glApp3, SIGNAL( _actualizarDatos( void ) ), this, SLOT( actualizarDatosC( void ) ));

	connect( this, SIGNAL( _mover( void ) ), parent, SLOT( mover( void ) ) );	
	connect( this, SIGNAL( _rotar( void ) ), parent, SLOT( rotar( void ) ) );	
	connect( this, SIGNAL( _escalar( void ) ), parent, SLOT( escalar( void ) ) );	
	connect( this, SIGNAL( _recorte( void ) ), parent, SLOT( recorte( void ) ) );	
	connect( this, SIGNAL( _mirror( void ) ), parent, SLOT( mirror( void ) ) );	
	connect( this, SIGNAL( _material( void ) ), parent, SLOT( material( void ) ) );	
	connect( this, SIGNAL( _render( void ) ), parent, SLOT( render( void ) ) );	
	connect( this, SIGNAL( _renderGL( void ) ), parent, SLOT( renderGL( void ) ) );	
	
	connect( this, SIGNAL( _view_foto( void ) ), parent, SLOT( view_foto( void ) ) );	

	connect( this, SIGNAL( _abrir_escena( void ) ), parent, SLOT( abrir_escena( void ) ) );	
	connect( this, SIGNAL( _nueva_escena( void ) ), parent, SLOT( nueva_escena( void ) ) );	
	connect( this, SIGNAL( _grabar_escena( void ) ), parent, SLOT( guardar_escena( void ) ) );	
	connect( this, SIGNAL( _grabar_escena_rib( void ) ), parent, SLOT( guardar_escena_rib( void ) ) );	
		
}

void interfaz :: actualizarDatosX( void )
{
	switch( view0 -> id( view0 -> selected( ) ) )
	{
	  case 0:
	    emit _actualizarDatosX( 3, ( near0 -> text() ).toFloat(), ( far0 -> text() ).toFloat(), 0.0, ( zoom0 -> text() ).toFloat(), bg0 -> color_object, ( ( sh0 -> id( sh0 -> selected( ) ) ) == 1 ) );
	    break;
	  case 1:
	    emit _actualizarDatosX( 5, ( near0 -> text() ).toFloat(), ( far0 -> text() ).toFloat(), 0.0, ( zoom0 -> text() ).toFloat(), bg0 -> color_object, ( ( sh0 -> id( sh0 -> selected( ) ) ) == 1 ) );
	    break;
	  case 2:
	    emit _actualizarDatosX( 7, ( near0 -> text() ).toFloat(), ( far0 -> text() ).toFloat(), 0.0, ( zoom0 -> text() ).toFloat(), bg0 -> color_object, ( ( sh0 -> id( sh0 -> selected( ) ) ) == 1 ) );
	    break;
	  case 3:
	    emit _actualizarDatosX( 9, ( near0 -> text() ).toFloat(), ( far0 -> text() ).toFloat(), 0.0, ( zoom0 -> text() ).toFloat(), bg0 -> color_object, ( ( sh0 -> id( sh0 -> selected( ) ) ) == 1 ) );
	    break;
	  case 4:
	    emit _actualizarDatosX( 11, ( near0 -> text() ).toFloat(), ( far0 -> text() ).toFloat(), 0.0, ( zoom0 -> text() ).toFloat(), bg0 -> color_object, ( ( sh0 -> id( sh0 -> selected( ) ) ) == 1 ) );
	    break;
	  case 5:
	    emit _actualizarDatosX( 13, ( near0 -> text() ).toFloat(), ( far0 -> text() ).toFloat(), 0.0, ( zoom0 -> text() ).toFloat(), bg0 -> color_object, ( ( sh0 -> id( sh0 -> selected( ) ) ) == 1 ) );
	    break;
  }
}

void interfaz :: actualizarDatosY( void )
{
	switch( view1 -> id( view1 -> selected( ) ) )
	{
	  case 0:
	    emit _actualizarDatosY( 3, ( near1 -> text() ).toFloat(), ( far1 -> text() ).toFloat(), 0.0, ( zoom1 -> text() ).toFloat(), bg1 -> color_object, ( ( sh1 -> id( sh1 -> selected( ) ) ) == 1 ) );
	    break;
	  case 1:
	    emit _actualizarDatosY( 5, ( near1 -> text() ).toFloat(), ( far1 -> text() ).toFloat(), 0.0, ( zoom1 -> text() ).toFloat(), bg1 -> color_object, ( ( sh1 -> id( sh1 -> selected( ) ) ) == 1 ) );
	    break;
	  case 2:
	    emit _actualizarDatosY( 7, ( near1 -> text() ).toFloat(), ( far1 -> text() ).toFloat(), 0.0, ( zoom1 -> text() ).toFloat(), bg1 -> color_object, ( ( sh1 -> id( sh1 -> selected( ) ) ) == 1 ) );
	    break;
	  case 3:
	    emit _actualizarDatosY( 9, ( near1 -> text() ).toFloat(), ( far1 -> text() ).toFloat(), 0.0, ( zoom1 -> text() ).toFloat(), bg1 -> color_object, ( ( sh1 -> id( sh1 -> selected( ) ) ) == 1 ) );
	    break;
	  case 4:
	    emit _actualizarDatosY( 11, ( near1 -> text() ).toFloat(), ( far1 -> text() ).toFloat(), 0.0, ( zoom1 -> text() ).toFloat(), bg1 -> color_object, ( ( sh1 -> id( sh1 -> selected( ) ) ) == 1 ) );
	    break;
	  case 5:
	    emit _actualizarDatosY( 13, ( near1 -> text() ).toFloat(), ( far1 -> text() ).toFloat(), 0.0, ( zoom1 -> text() ).toFloat(), bg1 -> color_object, ( ( sh1 -> id( sh1 -> selected( ) ) ) == 1 ) );
	    break;
  }
}

void interfaz :: actualizarDatosZ( void )
{
	switch( view2 -> id( view2 -> selected( ) ) )
	{
	  case 0:
	    emit _actualizarDatosZ( 3, ( near2 -> text() ).toFloat(), ( far2 -> text() ).toFloat(), 0.0, ( zoom2 -> text() ).toFloat(), bg2 -> color_object, ( ( sh2 -> id( sh2 -> selected( ) ) ) == 1 ) );
	    break;
	  case 1:
	    emit _actualizarDatosZ( 5, ( near2 -> text() ).toFloat(), ( far2 -> text() ).toFloat(), 0.0, ( zoom2 -> text() ).toFloat(), bg2 -> color_object, ( ( sh2 -> id( sh2 -> selected( ) ) ) == 1 ) );
	    break;
	  case 2:
	    emit _actualizarDatosZ( 7, ( near2 -> text() ).toFloat(), ( far2 -> text() ).toFloat(), 0.0, ( zoom2 -> text() ).toFloat(), bg2 -> color_object, ( ( sh2 -> id( sh2 -> selected( ) ) ) == 1 ) );
	    break;
	  case 3:
	    emit _actualizarDatosZ( 9, ( near2 -> text() ).toFloat(), ( far2 -> text() ).toFloat(), 0.0, ( zoom2 -> text() ).toFloat(), bg2 -> color_object, ( ( sh2 -> id( sh2 -> selected( ) ) ) == 1 ) );
	    break;
	  case 4:
	    emit _actualizarDatosZ( 11, ( near2 -> text() ).toFloat(), ( far2 -> text() ).toFloat(), 0.0, ( zoom2 -> text() ).toFloat(), bg2 -> color_object, ( ( sh2 -> id( sh2 -> selected( ) ) ) == 1 ) );
	    break;
	  case 5:
	    emit _actualizarDatosZ( 13, ( near2 -> text() ).toFloat(), ( far2 -> text() ).toFloat(), 0.0, ( zoom2 -> text() ).toFloat(), bg2 -> color_object, ( ( sh2 -> id( sh2 -> selected( ) ) ) == 1 ) );
	    break;
  }
}

void interfaz :: actualizarDatosC( void )
{
  emit _actualizarDatosC( 1, ( near3 -> text() ).toFloat(), ( far3 -> text() ).toFloat(), ( fov3 -> text() ).toFloat(), ( zoom3 -> text() ).toFloat(), bg3 -> color_object, ( ( sh3 -> id( sh3 -> selected( ) ) ) == 1 ) );
}

void interfaz :: next_frame( void )
{
		if ( this->frame_number->value() ==  this->frame_number->maxValue() )
			this->frame_number->setValue( 0 );		
			
    	 	if ( this->play_button->state( ) ) QTimer::singleShot( ( int ) 1000/this -> dialogo_time -> sync -> value(),  this->frame_number , SLOT( stepUp( void )  ) );
    	 	if ( this->play_button->state( ) ) QTimer::singleShot( ( int ) 1000/this -> dialogo_time -> sync -> value() ,  this , SLOT( next_frame( void )  ) );    	 	
    	 	
}

void interfaz :: stop( void )
{
    this->play_button->setOn( false );
}

void interfaz :: play( void )
{
    this->next_frame(  );
}

void interfaz :: timeline( void )
{
		
	if ( dialogo_time -> exec() ) {
		
		 this->frame_number->setMaxValue ( dialogo_time -> number -> value() );
		 this->frame_slider->setMaxValue ( dialogo_time -> number -> value() );		
	}
		
}

interfaz :: ~interfaz()
{
}

void interfaz :: material( void )
{
  emit _material( );
}
