/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef INTERFAZ_H
#define INTERFAZ_H

#include "defines.h"
#include "spinboxf.h"
#include "colorform_imp.h"
#include "glApplet.h"
#include "dialogo_timeline.h"
#include "dialogo_material.h"

class interfaz : public ventana  {
   Q_OBJECT
public: 
	interfaz( QObject *parent=0 );
	~interfaz();
	
	glApplet * glApp0;
	glApplet * glApp1;	
	glApplet * glApp2;
	glApplet * glApp3;
	
	dialogo_timeline * dialogo_time;

public slots:

 	void actualizarDatosX( void );
 	void actualizarDatosY( void );
 	void actualizarDatosZ( void );
	void actualizarDatosC( void );

	void play ( void );
	void stop ( void );
	void next_frame ( void );
  void timeline( void );

  void interpolar( void ){ emit _interpolar( ); }
  void abrir_escena( void ){ emit _abrir_escena( ); }
  void nueva_escena( void ){ emit _nueva_escena( ); }
  void grabar_escena( void ){ emit _grabar_escena( ); }
  void grabar_escena_rib( void ){ emit _grabar_escena_rib( ); }

  void dialogoAbout( void ){ system( "konqueror $XRIBHOME\"doc//index.html\" &" ); }
  void dialogo_ayuda( void ){ emit _dialogo_crear( ABOUT ); }
  void dialogo_crear_ambiental( void ){ emit _dialogo_crear_ambiental( ); }
  void dialogo_crear_omni( void ){ emit _dialogo_crear_omni( ); }
  void dialogo_crear_spot( void ){ emit _dialogo_crear_spot( ); }
  void dialogo_crear_prisma( void ){ emit _dialogo_crear( BOX ); }
  void dialogo_crear_toro( void ){ emit _dialogo_crear( TORUS ); }
  void dialogo_crear_esfera( void ){ emit _dialogo_crear( SPHERE ); }
  void dialogo_crear_cono( void ){ emit _dialogo_crear( CONE ); }
  void dialogo_crear_disco( void ){ emit _dialogo_crear( DISK ); }
  void dialogo_crear_cilindro( void ){ emit _dialogo_crear( CYLINDER ); }
  void dialogo_crear_hyperboloide( void ){ emit _dialogo_crear( HYPERBOLOID ); }
  void dialogo_camara( void ){ emit _dialogo_crear( CAMERA ); }
  void select_by_name( void ) { emit _seleccionarPrims( ); }
  void mover( void ) { emit _mover( ); }
  void rotar( void ) { emit _rotar( ); }
  void escalar( void ) { emit _escalar( ); }
  void recorte( void ) { emit _recorte( ); }
  void mirror( void ) { emit _mirror( ); }
  void render( void ) { emit _render( ); }
  void render_gl( void ) { emit _renderGL( ); }
  void material( void );

  void resetZoomS( void )
  {
    Slider2 -> setValue( 100 );
  }

  void record( void ) { emit _record( ); }
  void view_foto( void ) { emit _view_foto( ); }
  void setBKColor( void ) { emit _actBKColor( &( bg3 -> color_object ) ); }
  void cambiarAFrame( int cual ) { emit _cambiarAFrame( cual ); }
  void cambiarModoVisual( int cual, int modo )
  {
    switch( cual )
    {
      case 0:
        glApp0 -> cambiarModoVisual( modo );
        break;
      case 1:
        glApp1 -> cambiarModoVisual( modo );
        break;
      case 2:
        glApp2 -> cambiarModoVisual( modo );
        break;
      case 3:
        glApp3 -> cambiarModoVisual( modo );
        break;
    }
  }

  void cambiarCamara( int cual, int modo )
  {
    switch( cual )
    {
      case 0:
        glApp0 -> camaraGL = modo;
        break;
      case 1:
        glApp1 -> camaraGL = modo;
        break;
      case 2:
        glApp2 -> camaraGL = modo;
        break;
      case 3:
        glApp3 -> camaraGL = modo;
        break;
    }
  }

signals:

  void _dialogo_crear_ambiental( void );
  void _dialogo_crear_omni( void );
	void _dialogo_crear_spot( void );
  void _abrir_escena( void );
  void _nueva_escena( void );
  void _grabar_escena( void );
  void _grabar_escena_rib( void );
	void _view_foto( void );
  void _mover( void );
  void _rotar( void );
  void _escalar( void );
  void _recorte( void );
  void _mirror( void );
  void _material( void );
  void _record( void );
 	void _render( void );
 	void _renderGL( void );
  void _seleccionarPrims( void );
	void _interpolar( void );

	void _dialogo_crear( int );
  void _cambiarAFrame( int );
	
	void _actBKColor( QColor * );
 	
 	void _actualizarDatosX( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool );
 	void _actualizarDatosY( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool );
 	void _actualizarDatosZ( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool );
 	void _actualizarDatosC( GLuint, GLdouble, GLdouble, GLdouble, GLdouble, QColor, bool );
};

#endif
