/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mundo.h"

mundo	:: mundo( QObject *parent, const char *name, QString * cad, QString * cad2 )
			 : QObject( parent, name )
{
	cadRib = cad;
	luzRib = cad2;
	luzXRib = new QString( );
	cameraRIB = new QString( );
	tempC = new QString( );
  camera = new camara( cameraRIB );	
  tempC = 0;
  animando = false;
  dialAmb = new dialogo_ambiental( 0, 0, true );
  dialOmn = new dialogo_omni( 0, 0, true );
  dialSpo = new dialogo_spot( 0, 0, true );
  intL = 0.0;
  colL = new QColor( 0, 0, 0 );
  tempL = new QString( );
  tempL -> sprintf( "LightSource \"ambientlight\" 1 \"intensity\" [%.2f] \"lightcolor\" [%.2f %.2f %.2f] ", intL, colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0 );
  numLuces = 0;
  luces . append( tempL );
  ( * luzRib ) = ( * luzRib ) . append ( * tempL );
  tempL -> sprintf( "\nAMBIENT\n0 0 0 0" );
  lucesRIB . append( tempL );
  ( * luzXRib ) = ( * luzXRib ) . append ( * tempL );
  tempL = 0;

	connect(this, SIGNAL( _camera_edit( void ) ), camera, SLOT( generarInterModif( void ) ) );
	connect(this, SIGNAL( _cambiarAFrame( int ) ), camera, SLOT( cambiarAFrame( int ) ) );
	connect(this, SIGNAL( _record( void ) ), camera, SLOT( record( void ) ) );
	connect(this, SIGNAL( _record( uint, float, float, float, float, float, float ) ), camera, SLOT( record( uint, float, float, float, float, float, float ) ) );	
	connect(this, SIGNAL( _actualizarGL( void ) ), camera, SLOT( actualizarCamara( void ) ) );
	connect(camera, SIGNAL( _actualizarValor( void ) ), parent, SIGNAL( _actualizarGL( void ) ));
	connect(camera, SIGNAL( _ultKeyFrame( uint ) ), parent, SLOT( ultKeyFrame( uint ) ));
	connect(this, SIGNAL( _generarCodRIB( void ) ), camera, SLOT( generarCodRIB( void ) ) );
	connect(camera, SIGNAL( _RIBOk( void ) ), this, SLOT( generarCodRIBOk( void ) ));
	connect(camera, SIGNAL( _animOk( void ) ), this, SLOT( generarCodRIBOk( void ) ));
	connect(this, SIGNAL( _genRIBFrame( uint ) ), camera, SLOT( genRIBFrame( uint ) ) );
	connect(this, SIGNAL( _actualizarLuces( void ) ), parent, SIGNAL( _rePaint( void ) ) );
	connect(this, SIGNAL( _frameXRib( QString * ) ), camera, SLOT( genFrameXRib( QString * ) ) );
	connect(parent, SIGNAL( _interpolar( void ) ), camera, SLOT( interpolar( void ) ) );
	connect(camera, SIGNAL( _interpolarFin( void ) ), parent, SLOT( interpolarFin( void ) ) );
	
	connect(camera, SIGNAL( _frameOK( void ) ), parent, SLOT( ensamblarXRIB( void ) ));
	connect(camera, SIGNAL( _finXRIB( void ) ), parent, SLOT( generarXRIB( void ) ));
	connect(this, SIGNAL( _encabezadoOK( void ) ), parent, SLOT( genEncabezadoRIB( void ) ));
	
	connect(dialAmb -> intensidad, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesAmb( void ) ) );
	connect(dialAmb -> color, SIGNAL( _cambio( void ) ), this, SLOT( actLucesAmb( void ) ) );
	
	connect(dialOmn -> intensidad, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesOmn( void ) ) );
	connect(dialOmn -> X, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesOmn( void ) ) );
	connect(dialOmn -> Y, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesOmn( void ) ) );
	connect(dialOmn -> Z, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesOmn( void ) ) );
	connect(dialOmn -> color, SIGNAL( _cambio( void ) ), this, SLOT( actLucesOmn( void ) ) );

	connect(dialSpo -> intensidad, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesSpo( void ) ) );
	connect(dialSpo -> X, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesSpo( void ) ) );
	connect(dialSpo -> Y, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesSpo( void ) ) );
	connect(dialSpo -> Z, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesSpo( void ) ) );
	connect(dialSpo -> X2, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesSpo( void ) ) );
	connect(dialSpo -> Y2, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesSpo( void ) ) );
	connect(dialSpo -> Z2, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesSpo( void ) ) );
	connect(dialSpo -> angle, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesSpo( void ) ) );
	connect(dialSpo -> delta, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesSpo( void ) ) );
	connect(dialSpo -> beam, SIGNAL( valueChanged( int ) ), this, SLOT( actLucesSpo( void ) ) );
	connect(dialSpo -> color, SIGNAL( _cambio( void ) ), this, SLOT( actLucesSpo( void ) ) );

}

mundo :: ~mundo()
{
    for( uint i = 0; i < luces . count(); ++i )
      delete luces . at(i);
}

void mundo :: generarCodRIB( void )
{
  emit _generarCodRIB( );
}

void mundo :: generarCodRIBOk( void )
{
  cadRib -> truncate( 0 );
  ( * cadRib ) = ( * cadRib ) . append ( * cameraRIB );

  if( !animando )
    emit _RIBOk( );
  else
  {
    animando = false;
    emit _animOk( );
  }
}

void mundo :: genRIBFrame( uint donde )
{
  animando = true;
  emit _genRIBFrame( donde );
}

void mundo :: addAmb( void )
{
  tempL = luces . at( 0 );

  if( dialAmb -> exec() )
  {
    tempL -> sprintf( "\nLightSource \"ambientlight\" 1 \"intensity\" [%.2f] \"lightcolor\" [%.2f %.2f %.2f] ", intL, colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0 );

    luzRib -> truncate( 0 );

    for( uint i = 0; i < luces . count(); ++i )
  	{
    	( * luzRib ) = ( * luzRib ) . append ( * ( luces . at( i ) ) );
  	}
  	
  	tempL = lucesRIB . at( 0 );

	 	tempL -> sprintf( "\nAMBIENT\n%.2f %.2f %.2f %.2f", intL, colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0 );
    	  	
  	luzXRib -> truncate( 0 );

    for( uint i = 0; i < lucesRIB . count(); ++i )
  	{
    	( * luzXRib ) = ( * luzXRib ) . append ( * ( lucesRIB . at( i ) ) );
  	}
  }
}

void mundo :: addOmn( void )
{
  ++numLuces;
  this -> actLucesOmn();

  if( dialOmn -> exec() )
  {
    tempL = new QString( );
    tempL -> sprintf( "\nLightSource \"pointlight\" %d \"intensity\" [%.2f] \"lightcolor\" [%.2f %.2f %.2f] \"from\" [%.2f %.2f %.2f]", luces . count() + 1, intL, colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0, dxL, dyL, -1 * dzL );
    ( * luzRib ) = ( * luzRib ) . append ( * tempL );
  	luces . append( tempL );
  	
    tempL = new QString( );
    tempL -> sprintf( "\nOMNI\n%.2f %.2f %.2f %.2f %.2f %.2f %.2f", intL, colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0, dxL, dyL, dzL );
    ( * luzXRib ) = ( * luzXRib ) . append ( * tempL );
  	lucesRIB . append( tempL );
  	tempL = 0;
  }
  else
 	{
    /*glNewList( 21 + numLuces * 2, GL_COMPILE );
		glEndList();*/
		glDeleteLists( 21 + numLuces * 2, 1 );
		
		glNewList( 21, GL_COMPILE );
		for(uint i = 23; i < 23 + numLuces*2; i += 2)
	  	glCallList( i );
		glEndList();
    --numLuces;
    emit _actualizarLuces( );
  }
}
void mundo :: addSpo( void )
{
  ++numLuces;
  this -> actLucesSpo( );

  if( dialSpo -> exec() )
  {
    tempL = new QString( );
    tempL -> sprintf( "\nLightSource \"spotlight\" %d \"intensity\" [%.2f] \"lightcolor\" [%.2f %.2f %.2f] \"from\" [%.2f %.2f %.2f] \"to\" [%.2f %.2f %.2f] \"coneangle\" [%.2f] \"conedeltaangle\" [%.2f] \"beamdistribution\" [%.2f]", luces . count() + 1, intL, colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0, dxL, dyL, -1 * dzL, txL, tyL, -1 * tzL, angL, delL, disL );
    ( * luzRib ) = ( * luzRib ) . append ( * tempL );
  	luces . append( tempL );
  	
    tempL = new QString( );
    tempL -> sprintf( "\nSPOT\n%.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f", intL, colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0, dxL, dyL, dzL, txL, tyL, tzL, angL, delL, disL );
    ( * luzXRib ) = ( * luzXRib ) . append ( * tempL );
  	lucesRIB . append( tempL ); 	
  	tempL = 0;
 	}
 	else
 	{
    /*glNewList( 21 + numLuces * 2, GL_COMPILE );
		glEndList();*/
		glDeleteLists( 21 + numLuces * 2, 1 );
		
		glNewList( 21, GL_COMPILE );
		for(uint i = 23; i < 23 + numLuces*2; i += 2)
	  	glCallList( i );
		glEndList();
    --numLuces;
    emit _actualizarLuces( );
  }
}


void mundo :: addAmb( float inten, float colR, float colG, float colB )
{
  tempL = luces . at( 0 );

  intL = inten;
  tempL -> sprintf( "\nLightSource \"ambientlight\" 1 \"intensity\" [%.2f] \"lightcolor\" [%.2f %.2f %.2f] ", intL, colR, colG, colB );

  luzRib -> truncate( 0 );

  for( uint i = 0; i < luces . count(); ++i )
	{
    	( * luzRib ) = ( * luzRib ) . append ( * ( luces . at( i ) ) );
 	}
 	
 	tempL = lucesRIB . at( 0 );
 	
 	tempL -> sprintf( "\nAMBIENT\n%.2f %.2f %.2f %.2f", intL, colR, colG, colB );
  	
 	luzXRib -> truncate( 0 );

  for( uint i = 0; i < lucesRIB . count(); ++i )
 	{
   	( * luzXRib ) = ( * luzXRib ) . append ( * ( lucesRIB . at( i ) ) );
 	}

}

void mundo :: addOmn( float inten, float colR, float colG, float colB, float X, float Y, float Z )
{
  intL = inten;
  dxL = X;
  dyL = Y;
  dzL = Z;
  tempL -> sprintf( "\nLightSource \"pointlight\" %d \"intensity\" [%.2f] \"lightcolor\" [%.2f %.2f %.2f] \"from\" [%.2f %.2f %.2f]", luces . count() + 1, intL, colR, colG, colB, dxL, dyL, -1 * dzL );
  colL = new QColor( (int)( colR * 255 ), (int)( colG * 255 ), (int)( colB * 255 ) );
  ( * luzRib ) = ( * luzRib ) . append ( * tempL );
  ++numLuces;
	luces . append( tempL );
   tempL = new QString( );
   tempL -> sprintf( "\nOMNI\n%.2f %.2f %.2f %.2f %.2f %.2f %.2f", intL, colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0, dxL, dyL, dzL );
   ( * luzXRib ) = ( * luzXRib ) . append ( * tempL );
 	lucesRIB . append( tempL );
 	tempL = 0;
  	
 	glNewList( 21 + numLuces * 2, GL_COMPILE );
   	glPointSize( 5 );
    glBegin(GL_POINTS);
	  	glColor3f( colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0 );
	  	glVertex3f( dxL, dyL, dzL);
  	glEnd();
	glEndList();
		
	glNewList( 21, GL_COMPILE );
	for(uint i = 23; i < 23 + numLuces*2; i += 2)
	  glCallList( i );
	glEndList();
}

void mundo :: addSpo( float inten, float colR, float colG, float colB, float X, float Y, float Z, float x, float y, float z, float ang, float del, float bea )
{
    tempL = new QString( );
    intL = inten;
    dxL = X;
    dyL = Y;
    dzL = Z;
    txL = x;
    tyL = y;
    tzL = z;
    angL = ang;
    delL = del;
    disL = bea;
	  colL = new QColor( (int)( colR * 255 ), (int)( colG * 255 ), (int)( colB * 255 ) );
    tempL -> sprintf( "\nLightSource \"spotlight\" %d \"intensity\" [%.2f] \"lightcolor\" [%.2f %.2f %.2f] \"from\" [%.2f %.2f %.2f] \"to\" [%.2f %.2f %.2f] \"coneangle\" [%.2f] \"conedeltaangle\" [%.2f] \"beamdistribution\" [%.2f]", luces . count() + 1, intL, colR, colG, colB, dxL, dyL, -1 * dzL, txL, tyL, -1 * tzL, angL, delL, disL );
    ( * luzRib ) = ( * luzRib ) . append ( * tempL );
    ++numLuces;
  	luces . append( tempL );

    tempL = new QString( );
    tempL -> sprintf( "\nSPOT\n%.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f", intL, colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0, dxL, dyL, dzL, txL, tyL, tzL, angL, delL, disL );
    ( * luzXRib ) = ( * luzXRib ) . append ( * tempL );
  	lucesRIB . append( tempL ); 	
  	
  	tempL = 0;
  	
  	glNewList( 21 + numLuces*2, GL_COMPILE );
	    glLineStipple( 3, 42 );
  	  glBegin(GL_LINES);
				glColor3f( colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0 );	 		  glVertex3f( dxL, dyL, dzL);
 		  	glVertex3f( txL, tyL, tzL);
	  	glEnd();
		glEndList();
		
		glNewList( 21, GL_COMPILE );
			for(uint i = 23; i < 23 + numLuces*2; i += 2)
		  	glCallList( i );
		glEndList();
}

void mundo :: actLucesAmb( void )
{
    * colL = dialAmb -> color -> color_object;
    intL = (dialAmb -> intensidad -> text()).toFloat();
}

void mundo :: actLucesSpo( void )
{
  intL = (dialSpo -> intensidad -> text()).toFloat();
  * colL = dialSpo -> color -> color_object;
  dxL = (dialSpo -> X -> text()).toFloat();
  dyL = (dialSpo -> Y -> text()).toFloat();
  dzL = (dialSpo -> Z -> text()).toFloat();
  txL = (dialSpo -> X2 -> text()).toFloat();
  tyL = (dialSpo -> Y2 -> text()).toFloat();
  tzL = (dialSpo -> Z2 -> text()).toFloat();
  angL = (dialSpo -> angle -> text()).toFloat();
  delL = (dialSpo -> delta -> text()).toFloat();
  disL = (dialSpo -> beam -> text()).toFloat();

  	glNewList( 21 + numLuces*2, GL_COMPILE );
	    glLineStipple( 3, 42 );
  	  glBegin(GL_LINES);
	      glColor3f( colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0 );
	 		  glVertex3f( dxL, dyL, dzL);
 		  	glVertex3f( txL, tyL, tzL);
	  	glEnd();
		glEndList();
		
		glNewList( 21, GL_COMPILE );
		for(uint i = 23; i < 23 + numLuces*2; i += 2)
		  glCallList( i );
		glEndList();
	emit _actualizarLuces( );	
}

void mundo :: actLucesOmn( void )
{
  intL = (dialOmn -> intensidad -> text()).toFloat();
  * colL = dialOmn -> color -> color_object;
  dxL = (dialOmn -> X -> text()).toFloat();
  dyL = (dialOmn -> Y -> text()).toFloat();
  dzL = (dialOmn -> Z -> text()).toFloat();
  	
  	glNewList( 21 + numLuces*2, GL_COMPILE );
    	glPointSize( 5 );
	    glBegin(GL_POINTS);
	      glColor3f( colL -> red() / 255.0, colL -> green() / 255.0, colL -> blue() / 255.0 );
 		  	glVertex3f( dxL, dyL, dzL);
	  	glEnd();
		glEndList();
		
		glNewList( 21, GL_COMPILE );
		for(uint i = 23; i < 23 + numLuces*2; i += 2)
		  glCallList( i );
		glEndList();
	emit _actualizarLuces( );
}

void mundo :: encabezadoXRIB( void )
{
  cadRib -> sprintf( "\nLUCES%s", luzXRib -> latin1() );
  emit _encabezadoOK( );
}

void mundo :: frameXRIB( void )
{
  emit _frameXRib( cadRib );
}

