/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


/*	El objeto mundo debe de encargarse del entorno de la escena, es decir,
		nos dice que cmaras y luces existen y cuales son sus cualidades, que
		caractersticas tiene la escena en cuanto al viewport se refiere (ventana
		de salida ya sea del render o de visualizacin).

		En sentido general, el mundo debe de encargarse de dar los encabezados
		o configuracin tanto del visualizador (GL) como del render (RIB).
*/

#ifndef MUNDO_H
#define MUNDO_H

#include "defines.h"
#include "camara.h"
#include "spinboxf.h"
#include "colorform_imp.h"
#include "dialogo_ambiental.h"
#include "dialogo_omni.h"
#include "dialogo_spot.h"

class mundo : public QObject
{
  Q_OBJECT

	public:

		mundo( QObject *parent=0, const char *name=0, QString * cad = 0, QString * cad2 = 0 );
		~mundo();

	public slots:
  	
  	void generarCodRIB( void );
  	void generarCodRIBOk( void );
  	void addAmb( void );
  	void addOmn( void );
  	void addSpo( void );
	  void actLucesAmb( void );
	  void actLucesOmn( void );
	  void actLucesSpo( void );
	  void frameXRIB( void );
	  void encabezadoXRIB( void );  	

   	void genRIBFrame( uint );
	    	
  	void addSpo( float inten, float colR, float colG, float colB, float X, float Y, float Z, float x, float y, float z, float ang, float del, float bea );
  	void addOmn( float inten, float colR, float colG, float colB, float X, float Y, float Z );
  	void addAmb( float inten, float colR, float colG, float colB );

	
	protected:
	
		camara * camera;
		
		QString * cadRib;
		QString * luzRib;
		QString * luzXRib;
    QString * cameraRIB;
    QString * tempC;
    QString * tempL;

    bool animando;

    dialogo_ambiental * dialAmb;
    dialogo_omni * dialOmn;
    dialogo_spot * dialSpo;

    QList <QString> luces;
    QList <QString> lucesRIB;

    float intL;
    float txL;
    float tyL;
    float tzL;
    float dxL;
    float dyL;
    float dzL;
    float angL;
    float delL;
    float disL;

    QColor * colL;

    uint numLuces;


	private:

	signals:

		void _camera_edit( void );
		void _actualizarGL( void );
		void _generarCodRIB( void );
		void _encabezadoOK( void );
		void _record( void );
		void _RIBOk( void );
		void _animOk( void );
		void _actualizarLuces( void );
		
		void _frameXRib( QString * );
		
		void _cambiarAFrame( int );
		
		void _genRIBFrame( uint );
		void _generarCodGL( GLuint );
		
		void _record( uint, float, float, float, float, float, float );
		
};
#endif
