/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PRIMCONO_H
#define PRIMCONO_H

#include "defines.h"
#include "primHyper.h"
#include "colorform_imp.h"
#include "spinboxf.h"
#include "dialogo_crear_cono.h"

class primCono : public primHyper
{
  Q_OBJECT

	public:

		primCono( QObject* parent, const char* name, int numFrames, GLuint Lista, QString * cadRib )
							: primHyper( parent, name, numFrames, Lista, cadRib )
		{
			x1 = 0.0;
			y1 = 0.0;
			z1 = -5.0; //altura
			
			x2 = 5.0; //radio
			y2 = 0.0;
			z2 = 0.0;
			
			The = 360.0;
			this -> recalcularValoresIniciales( );
		}
	
		primCono( QObject* parent, const char* name, int numFrames, GLuint Lista, QString * cadRib, QColor *Color, float Altura, float Radio, float theta, QString * mater )
							: primHyper( parent, name, numFrames, Lista, cadRib )
		{
			x1 = 0.0;
			y1 = 0.0;
			z1 = Altura; //altura
			
			x2 = Radio; //radio
			y2 = 0.0;
			z2 = 0.0;
			
			The = theta;
			
			color = Color;
			
			matRib = mater;
			this -> recalcularValoresIniciales( );
		}
		
		~primCono()
		{
		}

	public slots:
		void generarCodRIB( void );
		void generarInterCreac( void );
		void actualizarValores( void );
    void encabezadoXRIB( void );
    void genFrameXRib( void );
	protected:

	  dialogo_crear_cono * dialogo;

};
#endif
