/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "primDisco.h"

void primDisco :: generarCodRIB( void )
{
  QString * tempo;

  tempo = new QString( );
  cadRIB -> truncate( 0 );
	
  tempo -> sprintf( "\n\n#DISCO %s %0.2f %0.2f %0.2f\n\n", nombre -> latin1(), z1, x2, The );

	cadRIB -> append( * tempo );
	
	cadRIB -> append( "AttributeBegin\n" );
	
	if( !( matRib -> length() > 1 ) )
	{
	  tempo -> sprintf( "Color [ %.2f %.2f %.2f ]\n", (float)(color -> red( ))/255.0, (float)(color -> green( ))/255.0, (float)(color -> blue( ))/255.0 );
		cadRIB -> append( * tempo );
	}
	else
		cadRIB -> append( * matRib );
	
	tempo -> sprintf( "ConcatTransform %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f\n", ( *( actualM -> mat ) )( 0, 0 ), ( *( actualM -> mat ) )( 1, 0 ), -1 * ( *( actualM -> mat ) )( 2, 0 ), ( *( actualM -> mat ) )( 3, 0 ), ( *( actualM -> mat ) )( 0, 1 ), ( *( actualM -> mat ) )( 1, 1 ), -1 * ( *( actualM -> mat ) )( 2, 1 ), ( *( actualM -> mat ) )( 3, 1 ), -1 * ( *( actualM -> mat ) )( 0, 2 ), -1 * ( *( actualM -> mat ) )( 1, 2 ), ( *( actualM -> mat ) )( 2, 2 ), ( *( actualM -> mat ) )( 3, 2 ), ( *( actualM -> mat ) )( 0, 3 ), ( *( actualM -> mat ) )( 1, 3 ), -1 * ( *( actualM -> mat ) )( 2, 3 ), ( *( actualM -> mat ) )( 3, 3 ) );
	
	cadRIB -> append( * tempo );
		
	tempo -> sprintf( "Disk %0.2f %0.2f %0.2f\n", -1 * z1, x2, The );

	cadRIB -> append( * tempo );

	cadRIB -> append( "AttributeEnd\n" );

	if( !animando )
	  emit _RIBOk( );
}

void primDisco :: actualizarValores( void )
{
 	x1 = 0.0;
  y1 = 0.0;
  z1 = -1 * (dialogo -> height -> text()).toFloat();
  x2 = (dialogo -> radius -> text()).toFloat();
  y2 = 0.0;
  z2 = -1 * (dialogo -> height -> text()).toFloat();
 	The = (dialogo -> theta -> text()).toFloat();
   	
	this -> recalcularValoresIniciales( );

  color -> setRgb( dialogo -> color_panel -> color_object . rgb( ) );

  *nombre = dialogo -> nombre -> text( );

  emit _actualizarValor( );
}

void primDisco :: generarInterCreac( void )
{
	if ( !noGen ) {
		dialogo = new dialogo_crear_disco( 0, "", true ); //(QWidget *) this, "", true );
		
		connect( dialogo -> radius, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );	
		connect( dialogo -> height, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> theta, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );
    connect( dialogo -> color_panel, SIGNAL( _cambio( void ) ), this, SLOT( actualizarValores( ) ) );		

    dialogo -> nombre -> setText( *nombre );
		
		connect( dialogo -> nombre, SIGNAL( textChanged( const QString & ) ), this, SIGNAL( _revisarNombre( const QString & ) ) );

    this -> actualizarValores( );
				
   	if(dialogo -> exec())
   	{
   	  delete nombre;
   	  nombre = new QString ( dialogo -> nombre -> text( ) );
   	  delete dialogo;
   		dialogo = 0;
   	  emit _objetoCreado( );
   	}
   	else
   	{
   	  delete dialogo;
   		dialogo = 0;
   	  emit _objetoNoCreado( );
   	}
   	noGen = true;
	}

}

void primDisco :: encabezadoXRIB( void )
{
	if( !( matRib -> length() > 1 ) )
 	 cadRIB -> sprintf( "\nDISK\n%s\n%s%d %d %d %.2f %.2f %.2f ", nombre -> latin1(), matRib -> latin1(), color -> red(), color -> green(), color -> blue(), z1, x2, The );
  else
  	cadRIB -> sprintf( "\nDISK\nMATERIAL\n%s%s\n%d %d %d %.2f %.2f %.2f ", matRib -> latin1(), nombre -> latin1(), color -> red(), color -> green(), color -> blue(), z1, x2, The );
  emit _encabezadoOK();
}

void primDisco :: genFrameXRib( void )
{
  QString  * tempoC;

  tempoC = new QString();

  cadRIB -> truncate(0);

	for (uint  n = 0 ; n < frames.count() ; n++ )
	{
    tempoC -> sprintf( "\nFRAME\n%d\n%s\n%.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f", frames . at(n) -> number,nombre -> latin1(), ( *( frames . at( n ) -> mat ) )( 0, 0 ), ( *( frames . at( n ) -> mat ) )( 1, 0 ), ( *( frames . at( n ) -> mat ) )( 2, 0 ), ( *( frames . at( n ) -> mat ) )( 3, 0 ), ( *( frames . at( n ) -> mat ) )( 0, 1 ), ( *( frames . at( n ) -> mat ) )( 1, 1 ), ( *( frames . at( n ) -> mat ) )( 2, 1 ), ( *( frames . at( n ) -> mat ) )( 3, 1 ), ( *( frames . at( n ) -> mat ) )( 0, 2 ), ( *( frames . at( n ) -> mat ) )( 1, 2 ), ( *( frames . at( n ) -> mat ) )( 2, 2 ), ( *( frames . at( n ) -> mat ) )( 3, 2 ), ( *( frames . at( n ) -> mat ) )( 0, 3 ), ( *( frames . at( n ) -> mat ) )( 1, 3 ), ( *( frames . at( n ) -> mat ) )( 2, 3 ), ( *( frames . at( n ) -> mat ) )( 3, 3 ) );
	
		cadRIB -> append( *tempoC );
	}
	
	emit _finXRIB( );

}
