/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "primEsfera.h"

void primEsfera :: generarCodGL( void )
{
	int limSup, limInf, limExt;
  GLfloat temp[4][3];
	GLfloat m[16];
	pMatrix tempM;
		
	if( Zmax <= R )
	  limSup = ( int )( iterIn * Zmax / R );
	else
		limSup = iterIn;
	
	if( ( -1 * Zmin ) <= R )
	  limInf = ( int )( iterIn * ( -1 * Zmin ) / R );
	else
		limInf = iterIn;
	
	glNewList( lista, GL_COMPILE );

  if( selecc )
  	glColor3f( 1.0, 1.0, 1.0 );
	else
	  glColor3f( (GLfloat)(color -> red( ))/255.0, (GLfloat)(color -> green( ))/255.0, (GLfloat)(color -> blue( ))/255.0 );	

  if( The < 90.0 )
    limExt = (int)(The * iterEx / 90.0);
  else
    limExt = iterEx;

	tempM = new Matrix( 4, 1 );
	
	* tempM = ( *( actualM -> mat ) ) * * preview ;
	
	for(int i = 0, h; i < 4; ++i)
	  for(h = 0; h < 4; ++h)
	    m[i*4+h] = ( * tempM )( h, i );

	glPushMatrix( );
	glMultMatrixf( m );
 	 	  	
 	for(int i = 0, h = 0; i < limExt; ++i)
 	{
  	for(h = 0; h < limSup; ++h)
  	{
   		temp[0][0] = ( *(_puntos1[i][h]) )( 0, 0 );
   		temp[0][1] = ( *(_puntos1[i][h]) )( 1, 0 );
   		temp[0][2] = ( *(_puntos1[i][h]) )( 2, 0 );
   		temp[1][0] = ( *(_puntos1[i][h + 1]) )( 0, 0 );
   		temp[1][1] = ( *(_puntos1[i][h + 1]) )( 1, 0 );
   		temp[1][2] = ( *(_puntos1[i][h + 1]) )( 2, 0 );
   		temp[2][0] = ( *(_puntos1[i + 1][h + 1]) )( 0, 0 );
   		temp[2][1] = ( *(_puntos1[i + 1][h + 1]) )( 1, 0 );
   		temp[2][2] = ( *(_puntos1[i + 1][h + 1]) )( 2, 0 );
   		temp[3][0] = ( *(_puntos1[i + 1][h]) )( 0, 0 );
   		temp[3][1] = ( *(_puntos1[i + 1][h]) )( 1, 0 );
   		temp[3][2] = ( *(_puntos1[i + 1][h]) )( 2, 0 );

   		glBegin(GL_POLYGON);
    		glVertex3fv(temp[0]);
    		glVertex3fv(temp[1]);
    		glVertex3fv(temp[2]);
    		glVertex3fv(temp[3]);
   		glEnd();
  	}
 	}

 	for(int i = 0, h = 0; i < limExt; ++i)
 	{
  	for(h = 0; h < limInf; ++h)
  	{
   		temp[0][0] = ( *(_puntos2[i][h]) )( 0, 0 );
   		temp[0][1] = ( *(_puntos2[i][h]) )( 1, 0 );
   		temp[0][2] = ( *(_puntos2[i][h]) )( 2, 0 );
   		temp[1][0] = ( *(_puntos2[i][h + 1]) )( 0, 0 );
   		temp[1][1] = ( *(_puntos2[i][h + 1]) )( 1, 0 );
   		temp[1][2] = ( *(_puntos2[i][h + 1]) )( 2, 0 );
   		temp[2][0] = ( *(_puntos2[i + 1][h + 1]) )( 0, 0 );
   		temp[2][1] = ( *(_puntos2[i + 1][h + 1]) )( 1, 0 );
   		temp[2][2] = ( *(_puntos2[i + 1][h + 1]) )( 2, 0 );
   		temp[3][0] = ( *(_puntos2[i + 1][h]) )( 0, 0 );
   		temp[3][1] = ( *(_puntos2[i + 1][h]) )( 1, 0 );
   		temp[3][2] = ( *(_puntos2[i + 1][h]) )( 2, 0 );

   		glBegin(GL_POLYGON);
    		glVertex3fv(temp[0]);
    		glVertex3fv(temp[1]);
    		glVertex3fv(temp[2]);
    		glVertex3fv(temp[3]);
   		glEnd();
		}
	}

	if( The > 90.0 )
	{
	  if( The < 180.0 )
   	  limExt = (int)(( The - 90.0 ) * iterEx / 90.0);
   	else
   	  limExt = iterEx;
 		
 		for(int i = (iterEx - limExt), h = 0; i < iterEx; ++i)
	 	{
  		for(h = 0; h < limSup; ++h)
	  	{
  	 		temp[0][0] = ( *(_puntos3[i][h]) )( 0, 0 );
	   		temp[0][1] = ( *(_puntos3[i][h]) )( 1, 0 );
   			temp[0][2] = ( *(_puntos3[i][h]) )( 2, 0 );
  	 		temp[1][0] = ( *(_puntos3[i][h + 1]) )( 0, 0 );
	   		temp[1][1] = ( *(_puntos3[i][h + 1]) )( 1, 0 );
   			temp[1][2] = ( *(_puntos3[i][h + 1]) )( 2, 0 );
   			temp[2][0] = ( *(_puntos3[i + 1][h + 1]) )( 0, 0 );
  	 		temp[2][1] = ( *(_puntos3[i + 1][h + 1]) )( 1, 0 );
	   		temp[2][2] = ( *(_puntos3[i + 1][h + 1]) )( 2, 0 );
   			temp[3][0] = ( *(_puntos3[i + 1][h]) )( 0, 0 );
   			temp[3][1] = ( *(_puntos3[i + 1][h]) )( 1, 0 );
  	 		temp[3][2] = ( *(_puntos3[i + 1][h]) )( 2, 0 );

   			glBegin(GL_POLYGON);
    			glVertex3fv(temp[0]);
    			glVertex3fv(temp[1]);
    			glVertex3fv(temp[2]);
    			glVertex3fv(temp[3]);
   			glEnd();
			}
		}

 		for(int i = (iterEx - limExt), h = 0; i < iterEx; ++i)
 		{
  		for(h = 0; h < limInf; ++h)
  		{
	   		temp[0][0] = ( *(_puntos4[i][h]) )( 0, 0 );
   			temp[0][1] = ( *(_puntos4[i][h]) )( 1, 0 );
   			temp[0][2] = ( *(_puntos4[i][h]) )( 2, 0 );
  	 		temp[1][0] = ( *(_puntos4[i][h + 1]) )( 0, 0 );
	   		temp[1][1] = ( *(_puntos4[i][h + 1]) )( 1, 0 );
   			temp[1][2] = ( *(_puntos4[i][h + 1]) )( 2, 0 );
   			temp[2][0] = ( *(_puntos4[i + 1][h + 1]) )( 0, 0 );
  	 		temp[2][1] = ( *(_puntos4[i + 1][h + 1]) )( 1, 0 );
	   		temp[2][2] = ( *(_puntos4[i + 1][h + 1]) )( 2, 0 );
   			temp[3][0] = ( *(_puntos4[i + 1][h]) )( 0, 0 );
  			temp[3][1] = ( *(_puntos4[i + 1][h]) )( 1, 0 );
	  		temp[3][2] = ( *(_puntos4[i + 1][h]) )( 2, 0 );

			  glBegin(GL_POLYGON);
			  	glVertex3fv(temp[0]);
			    glVertex3fv(temp[1]);
			    glVertex3fv(temp[2]);
			    glVertex3fv(temp[3]);
		   glEnd();
			}
		}
	}

	if( The > 180 )
	{
	  if( The < 270.0 )
   	  limExt = (int)(( The - 180.0 ) * iterEx / 90.0);
   	else
   	  limExt = iterEx;
		
		for(int i = 0, h = 0; i < limExt; ++i)
		{
			for(h = 0; h < limSup; ++h)
		  {
	   		temp[0][0] = ( *(_puntos5[i][h]) )( 0, 0 );
   			temp[0][1] = ( *(_puntos5[i][h]) )( 1, 0 );
   			temp[0][2] = ( *(_puntos5[i][h]) )( 2, 0 );
  	 		temp[1][0] = ( *(_puntos5[i][h + 1]) )( 0, 0 );
	   		temp[1][1] = ( *(_puntos5[i][h + 1]) )( 1, 0 );
   			temp[1][2] = ( *(_puntos5[i][h + 1]) )( 2, 0 );
   			temp[2][0] = ( *(_puntos5[i + 1][h + 1]) )( 0, 0 );
  	 		temp[2][1] = ( *(_puntos5[i + 1][h + 1]) )( 1, 0 );
	   		temp[2][2] = ( *(_puntos5[i + 1][h + 1]) )( 2, 0 );
   			temp[3][0] = ( *(_puntos5[i + 1][h]) )( 0, 0 );
  			temp[3][1] = ( *(_puntos5[i + 1][h]) )( 1, 0 );
	  		temp[3][2] = ( *(_puntos5[i + 1][h]) )( 2, 0 );

			  glBegin(GL_POLYGON);
			    glVertex3fv(temp[0]);
			    glVertex3fv(temp[1]);
			    glVertex3fv(temp[2]);
			    glVertex3fv(temp[3]);
			  glEnd();
			}
		}

		for(int i = 0, h = 0; i < limExt; ++i)
		{
			for(h = 0; h < limInf; ++h)
		  {
	   		temp[0][0] = ( *(_puntos6[i][h]) )( 0, 0 );
   			temp[0][1] = ( *(_puntos6[i][h]) )( 1, 0 );
   			temp[0][2] = ( *(_puntos6[i][h]) )( 2, 0 );
  	 		temp[1][0] = ( *(_puntos6[i][h + 1]) )( 0, 0 );
	   		temp[1][1] = ( *(_puntos6[i][h + 1]) )( 1, 0 );
   			temp[1][2] = ( *(_puntos6[i][h + 1]) )( 2, 0 );
   			temp[2][0] = ( *(_puntos6[i + 1][h + 1]) )( 0, 0 );
  	 		temp[2][1] = ( *(_puntos6[i + 1][h + 1]) )( 1, 0 );
	   		temp[2][2] = ( *(_puntos6[i + 1][h + 1]) )( 2, 0 );
   			temp[3][0] = ( *(_puntos6[i + 1][h]) )( 0, 0 );
  			temp[3][1] = ( *(_puntos6[i + 1][h]) )( 1, 0 );
	  		temp[3][2] = ( *(_puntos6[i + 1][h]) )( 2, 0 );

			  glBegin(GL_POLYGON);
			    glVertex3fv(temp[0]);
			    glVertex3fv(temp[1]);
			    glVertex3fv(temp[2]);
			    glVertex3fv(temp[3]);
			  glEnd();
		  }
		}
	}

	if( The > 270.0 )
	{
	  if( The < 360.0 )
   	  limExt = (int)(( The - 270.0 ) * iterEx / 90.0);
   	else
   	  limExt = iterEx;

		for(int i = (iterEx - limExt), h = 0; i < iterEx; ++i)
		{
			for(h = 0; h < limSup; ++h)
		  {
	   		temp[0][0] = ( *(_puntos7[i][h]) )( 0, 0 );
   			temp[0][1] = ( *(_puntos7[i][h]) )( 1, 0 );
   			temp[0][2] = ( *(_puntos7[i][h]) )( 2, 0 );
  	 		temp[1][0] = ( *(_puntos7[i][h + 1]) )( 0, 0 );
	   		temp[1][1] = ( *(_puntos7[i][h + 1]) )( 1, 0 );
   			temp[1][2] = ( *(_puntos7[i][h + 1]) )( 2, 0 );
   			temp[2][0] = ( *(_puntos7[i + 1][h + 1]) )( 0, 0 );
  	 		temp[2][1] = ( *(_puntos7[i + 1][h + 1]) )( 1, 0 );
	   		temp[2][2] = ( *(_puntos7[i + 1][h + 1]) )( 2, 0 );
   			temp[3][0] = ( *(_puntos7[i + 1][h]) )( 0, 0 );
  			temp[3][1] = ( *(_puntos7[i + 1][h]) )( 1, 0 );
	  		temp[3][2] = ( *(_puntos7[i + 1][h]) )( 2, 0 );
			
			  glBegin(GL_POLYGON);
			    glVertex3fv(temp[0]);
			    glVertex3fv(temp[1]);
			    glVertex3fv(temp[2]);
			    glVertex3fv(temp[3]);
			  glEnd();
			}
		}

 		for(int i = (iterEx - limExt), h = 0; i < iterEx; ++i)
		{
		  for(h = 0; h < limInf; ++h)
		  {
	   		temp[0][0] = ( *(_puntos8[i][h]) )( 0, 0 );
   			temp[0][1] = ( *(_puntos8[i][h]) )( 1, 0 );
   			temp[0][2] = ( *(_puntos8[i][h]) )( 2, 0 );
  	 		temp[1][0] = ( *(_puntos8[i][h + 1]) )( 0, 0 );
	   		temp[1][1] = ( *(_puntos8[i][h + 1]) )( 1, 0 );
   			temp[1][2] = ( *(_puntos8[i][h + 1]) )( 2, 0 );
   			temp[2][0] = ( *(_puntos8[i + 1][h + 1]) )( 0, 0 );
  	 		temp[2][1] = ( *(_puntos8[i + 1][h + 1]) )( 1, 0 );
	   		temp[2][2] = ( *(_puntos8[i + 1][h + 1]) )( 2, 0 );
   			temp[3][0] = ( *(_puntos8[i + 1][h]) )( 0, 0 );
  			temp[3][1] = ( *(_puntos8[i + 1][h]) )( 1, 0 );
	  		temp[3][2] = ( *(_puntos8[i + 1][h]) )( 2, 0 );

			  glBegin(GL_POLYGON);
			    glVertex3fv(temp[0]);
			    glVertex3fv(temp[1]);
			    glVertex3fv(temp[2]);
			    glVertex3fv(temp[3]);
			  glEnd();
			}
		}
	}

	glPopMatrix( );
	glEndList();
	emit _actualizacionPrimOK( );
}

void primEsfera :: generarCodRIB( void )
{
  QString * tempo;

  tempo = new QString( );
  cadRIB -> truncate( 0 );
	
  tempo -> sprintf( "\n\n#ESFERA %s %0.2f %0.2f %0.2f %0.2f\n\n", nombre -> latin1(), R, Zmin, Zmax, The );

	cadRIB -> append( * tempo );
	
	cadRIB -> append( "AttributeBegin\n" );
	
	if( !( matRib -> length() > 1 ) )
	{
	  tempo -> sprintf( "Color [ %.2f %.2f %.2f ]\n", (float)(color -> red( ))/255.0, (float)(color -> green( ))/255.0, (float)(color -> blue( ))/255.0 );
		cadRIB -> append( * tempo );
	}
	else
		cadRIB -> append( * matRib );
	
	tempo -> sprintf( "ConcatTransform %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f\n", ( *( actualM -> mat ) )( 0, 0 ), ( *( actualM -> mat ) )( 1, 0 ), -1 * ( *( actualM -> mat ) )( 2, 0 ), ( *( actualM -> mat ) )( 3, 0 ), ( *( actualM -> mat ) )( 0, 1 ), ( *( actualM -> mat ) )( 1, 1 ), -1 * ( *( actualM -> mat ) )( 2, 1 ), ( *( actualM -> mat ) )( 3, 1 ), -1 * ( *( actualM -> mat ) )( 0, 2 ), -1 * ( *( actualM -> mat ) )( 1, 2 ), ( *( actualM -> mat ) )( 2, 2 ), ( *( actualM -> mat ) )( 3, 2 ), ( *( actualM -> mat ) )( 0, 3 ), ( *( actualM -> mat ) )( 1, 3 ), -1 * ( *( actualM -> mat ) )( 2, 3 ), ( *( actualM -> mat ) )( 3, 3 ) );
	
	cadRIB -> append( * tempo );
		
	tempo -> sprintf( "Sphere %0.2f %0.2f %0.2f %0.2f\n", R, -1 * Zmin, -1 * Zmax, The );

	cadRIB -> append( * tempo );

	cadRIB -> append( "AttributeEnd\n" );

	if( !animando )
	  emit _RIBOk( );
}

void primEsfera :: actualizarValores( void )
{
 	R = (dialogo -> radius -> text()).toFloat();
  Zmax = (dialogo -> zmax -> text()).toFloat();
	Zmin = (dialogo -> zmin -> text()).toFloat();
 	The = (dialogo -> theta -> text()).toFloat();
   	
	this -> recalcularValoresIniciales( );
						
	color -> setRgb( dialogo -> color_panel -> color_object . rgb( ) );

  *nombre = dialogo -> nombre -> text( );

  emit _actualizarValor( );
}

void primEsfera :: generarInterCreac( void )
{
	if ( !noGen ) {
		dialogo = new dialogo_crear_esfera( 0, "", true ); //(QWidget *) this, "", true );
		
		connect( dialogo -> radius, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );	
		connect( dialogo -> zmax, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> zmin, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> theta, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
    connect( dialogo -> color_panel, SIGNAL( _cambio( void ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> nombre, SIGNAL( textChanged( const QString & ) ), this, SIGNAL( _revisarNombre( const QString & ) ) );

    dialogo -> nombre -> setText( *nombre );
    		
   	if(dialogo -> exec())
   	{
   	  delete nombre;
   	  nombre = new QString ( dialogo -> nombre -> text( ) );
   	  delete dialogo;
   		dialogo = 0;
   	  emit _objetoCreado( );
   	}
   	else
   	{
   	  delete dialogo;
   		dialogo = 0;
   	  emit _objetoNoCreado( );
   	}
   	
   	noGen = true;
	}

}

void primEsfera :: recalcularValoresIniciales( void )
{
 	GLfloat x, y, z, t, u;

 	for(int i = 0, h = 0; i <= iterEx; ++i)
 	{
  	u = (i*M_PI)/(2.0*iterEx);    // ngulo Mayor
   	for(h = 0; h <= iterIn; ++h)
   	{
    	t = (h*M_PI)/(2.0*iterIn);  // ngulo Menor
    	x = R*cos(u)*cos(t);
    	y = R*sin(u)*cos(t);
    	z = R*sin(t);

    	( *(_puntos1[i][h]) )( 0, 0 ) = x;
    	( *(_puntos1[i][h]) )( 1, 0 ) = y;
    	( *(_puntos1[i][h]) )( 2, 0 ) = -1 * z;
    	( *(_puntos1[i][h]) )( 3, 0 ) = 1.0;
   	
    	( *(_puntos2[i][h]) )( 0, 0 ) = x;
    	( *(_puntos2[i][h]) )( 1, 0 ) = y;
    	( *(_puntos2[i][h]) )( 2, 0 ) = z;
    	( *(_puntos2[i][h]) )( 3, 0 ) = 1.0;
   	
    	( *(_puntos3[i][h]) )( 0, 0 ) = -1 * x;
    	( *(_puntos3[i][h]) )( 1, 0 ) = y;
    	( *(_puntos3[i][h]) )( 2, 0 ) = -1 * z;
    	( *(_puntos3[i][h]) )( 3, 0 ) = 1.0;
   	
    	( *(_puntos4[i][h]) )( 0, 0 ) = -1 * x;
    	( *(_puntos4[i][h]) )( 1, 0 ) = y;
    	( *(_puntos4[i][h]) )( 2, 0 ) = z;
    	( *(_puntos4[i][h]) )( 3, 0 ) = 1.0;
   	
    	( *(_puntos5[i][h]) )( 0, 0 ) = -1 * x;
    	( *(_puntos5[i][h]) )( 1, 0 ) = -1 * y;
    	( *(_puntos5[i][h]) )( 2, 0 ) = -1 * z;
    	( *(_puntos5[i][h]) )( 3, 0 ) = 1.0;
   	
    	( *(_puntos6[i][h]) )( 0, 0 ) = -1 * x;
    	( *(_puntos6[i][h]) )( 1, 0 ) = -1 * y;
    	( *(_puntos6[i][h]) )( 2, 0 ) = z;
    	( *(_puntos6[i][h]) )( 3, 0 ) = 1.0;
   	
    	( *(_puntos7[i][h]) )( 0, 0 ) = x;
    	( *(_puntos7[i][h]) )( 1, 0 ) = -1 * y;
    	( *(_puntos7[i][h]) )( 2, 0 ) = -1 * z;
    	( *(_puntos7[i][h]) )( 3, 0 ) = 1.0;
   	
    	( *(_puntos8[i][h]) )( 0, 0 ) = x;
    	( *(_puntos8[i][h]) )( 1, 0 ) = -1 * y;
    	( *(_puntos8[i][h]) )( 2, 0 ) = z;
    	( *(_puntos8[i][h]) )( 3, 0 ) = 1.0;
   	
   	}
 	}
}

void primEsfera :: encabezadoXRIB( void )
{
	if( !( matRib -> length() > 1 ) )
 	  cadRIB -> sprintf( "\nSPHERE\n%s\n%s%d %d %d %.2f %.2f %.2f %.2f ", nombre -> latin1(), matRib -> latin1(), color -> red(), color -> green(), color -> blue(), R, Zmin, Zmax, The );
  else
	  cadRIB -> sprintf( "\nSPHERE\nMATERIAL\n%s%s\n%d %d %d %.2f %.2f %.2f %.2f ", matRib -> latin1(), nombre -> latin1(), color -> red(), color -> green(), color -> blue(), R, Zmin, Zmax, The );
  emit _encabezadoOK();
}

void primEsfera :: genFrameXRib( void )
{
  QString  * tempoC;

  tempoC = new QString();

  cadRIB -> truncate(0);

	for (uint  n = 0 ; n < frames.count() ; n++ )
	{
	  //cout << n << endl;
    tempoC -> sprintf( "\nFRAME\n%d\n%s\n%.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f", frames . at(n) -> number,nombre -> latin1(), ( *( frames . at( n ) -> mat ) )( 0, 0 ), ( *( frames . at( n ) -> mat ) )( 1, 0 ), ( *( frames . at( n ) -> mat ) )( 2, 0 ), ( *( frames . at( n ) -> mat ) )( 3, 0 ), ( *( frames . at( n ) -> mat ) )( 0, 1 ), ( *( frames . at( n ) -> mat ) )( 1, 1 ), ( *( frames . at( n ) -> mat ) )( 2, 1 ), ( *( frames . at( n ) -> mat ) )( 3, 1 ), ( *( frames . at( n ) -> mat ) )( 0, 2 ), ( *( frames . at( n ) -> mat ) )( 1, 2 ), ( *( frames . at( n ) -> mat ) )( 2, 2 ), ( *( frames . at( n ) -> mat ) )( 3, 2 ), ( *( frames . at( n ) -> mat ) )( 0, 3 ), ( *( frames . at( n ) -> mat ) )( 1, 3 ), ( *( frames . at( n ) -> mat ) )( 2, 3 ), ( *( frames . at( n ) -> mat ) )( 3, 3 ) );
		cadRIB -> append( *tempoC );
	}
	
	emit _finXRIB( );

}

