/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "primHyper.h"

void primHyper :: generarCodGL( void )
{
	GLfloat temp[4][3];
	int lim;
	GLfloat m[16];
	pMatrix tempM;
	
	glNewList( lista, GL_COMPILE );

  if( selecc )
  	glColor3f( 1.0, 1.0, 1.0 );
	else
	  glColor3f( (GLfloat)(color -> red( ))/255.0, (GLfloat)(color -> green( ))/255.0, (GLfloat)(color -> blue( ))/255.0 );	

	lim = (int)( The * N / 360.0 );

	tempM = new Matrix( 4, 1 );
	
	* tempM = ( *( actualM -> mat ) ) * * preview ;
	
	for(int i = 0, h; i < 4; ++i)
	  for(h = 0; h < 4; ++h)
	    m[i*4+h] = ( * tempM )( h, i );

	glPushMatrix( ); 		
	glMultMatrixf( m );
		
  for(int i = 0; i < lim-1; ++i)
 	{
  	temp[0][0] = ( *(_puntos1[i]) )( 0, 0 );
 		temp[0][1] = ( *(_puntos1[i]) )( 1, 0 );
 		temp[0][2] = ( *(_puntos1[i]) )( 2, 0 );
 		temp[1][0] = ( *(_puntos1[i + 1]) )( 0, 0 );
 		temp[1][1] = ( *(_puntos1[i + 1]) )( 1, 0 );
 		temp[1][2] = ( *(_puntos1[i + 1]) )( 2, 0 );
 		temp[2][0] = ( *(_puntos2[i + 1]) )( 0, 0 );
 		temp[2][1] = ( *(_puntos2[i + 1]) )( 1, 0 );
 		temp[2][2] = ( *(_puntos2[i + 1]) )( 2, 0 );
 		temp[3][0] = ( *(_puntos2[i]) )( 0, 0 );
 		temp[3][1] = ( *(_puntos2[i]) )( 1, 0 );
 		temp[3][2] = ( *(_puntos2[i]) )( 2, 0 );

   	glBegin(GL_POLYGON);
  	  glVertex3fv(temp[0]);
	    glVertex3fv(temp[1]);
    	glVertex3fv(temp[2]);
	    glVertex3fv(temp[3]);
   	glEnd();
 	}


 	if( lim > 0 )
 	{
	 	if(lim == N)
 		{
    	temp[0][0] = ( *(_puntos1[lim - 1]) )( 0, 0 );
	  	temp[0][1] = ( *(_puntos1[lim - 1]) )( 1, 0 );
		 	temp[0][2] = ( *(_puntos1[lim - 1]) )( 2, 0 );
 			temp[1][0] = ( *(_puntos1[0]) )( 0, 0 );
		 	temp[1][1] = ( *(_puntos1[0]) )( 1, 0 );
 			temp[1][2] = ( *(_puntos1[0]) )( 2, 0 );
	 		temp[2][0] = ( *(_puntos2[0]) )( 0, 0 );
	 		temp[2][1] = ( *(_puntos2[0]) )( 1, 0 );
		 	temp[2][2] = ( *(_puntos2[0]) )( 2, 0 );
 			temp[3][0] = ( *(_puntos2[lim - 1]) )( 0, 0 );
		 	temp[3][1] = ( *(_puntos2[lim - 1]) )( 1, 0 );
 			temp[3][2] = ( *(_puntos2[lim - 1]) )( 2, 0 );
	  }
  	else
	 	{ 	
  	  temp[0][0] = ( *(_puntos1[lim - 1]) )( 0, 0 );
  		temp[0][1] = ( *(_puntos1[lim - 1]) )( 1, 0 );
		 	temp[0][2] = ( *(_puntos1[lim - 1]) )( 2, 0 );
 			temp[1][0] = ( *(_puntos1[lim]) )( 0, 0 );
	 		temp[1][1] = ( *(_puntos1[lim]) )( 1, 0 );
	 		temp[1][2] = ( *(_puntos1[lim]) )( 2, 0 );
		 	temp[2][0] = ( *(_puntos2[lim]) )( 0, 0 );
 			temp[2][1] = ( *(_puntos2[lim]) )( 1, 0 );
		 	temp[2][2] = ( *(_puntos2[lim]) )( 2, 0 );
 			temp[3][0] = ( *(_puntos2[lim - 1]) )( 0, 0 );
	 		temp[3][1] = ( *(_puntos2[lim - 1]) )( 1, 0 );
	 		temp[3][2] = ( *(_puntos2[lim - 1]) )( 2, 0 );
  	}

	  glBegin(GL_POLYGON);
 		  glVertex3fv(temp[0]);
    	glVertex3fv(temp[1]);
	 	  glVertex3fv(temp[2]);
  	  glVertex3fv(temp[3]);
	 	glEnd();
	}

  glPopMatrix( );
	glEndList();
	emit _actualizacionPrimOK( );
}

void primHyper :: generarCodRIB( void )
{
  QString * tempo;

  tempo = new QString( );
  cadRIB -> truncate( 0 );
	
	tempo -> sprintf( "\n\n#HYPERBOLOIDE %s %0.2f %0.2f %0.2f %0.2f %0.2f %0.2f %0.2f\n\n", nombre -> latin1(), x1, y1, z1, x2, y2, z2, The );

	cadRIB -> append( * tempo );

	cadRIB -> append( "AttributeBegin\n" );
	
	if( !( matRib -> length() > 1 ) )
	{
	  tempo -> sprintf( "Color [ %.2f %.2f %.2f ]\n", (float)(color -> red( ))/255.0, (float)(color -> green( ))/255.0, (float)(color -> blue( ))/255.0 );
		cadRIB -> append( * tempo );
	}
	else
		cadRIB -> append( * matRib );
	
	tempo -> sprintf( "ConcatTransform %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f\n", ( *( actualM -> mat ) )( 0, 0 ), ( *( actualM -> mat ) )( 1, 0 ), -1 * ( *( actualM -> mat ) )( 2, 0 ), ( *( actualM -> mat ) )( 3, 0 ), ( *( actualM -> mat ) )( 0, 1 ), ( *( actualM -> mat ) )( 1, 1 ), -1 * ( *( actualM -> mat ) )( 2, 1 ), ( *( actualM -> mat ) )( 3, 1 ), -1 * ( *( actualM -> mat ) )( 0, 2 ), -1 * ( *( actualM -> mat ) )( 1, 2 ), ( *( actualM -> mat ) )( 2, 2 ), ( *( actualM -> mat ) )( 3, 2 ), ( *( actualM -> mat ) )( 0, 3 ), ( *( actualM -> mat ) )( 1, 3 ), -1 * ( *( actualM -> mat ) )( 2, 3 ), ( *( actualM -> mat ) )( 3, 3 ) );
	
	cadRIB -> append( * tempo );
		
	tempo -> sprintf( "Hyperboloid %0.2f %0.2f %0.2f %0.2f %0.2f %0.2f %0.2f\n", x1, y1, -1 * z1, x2, y2, -1 * z2, The );

	cadRIB -> append( * tempo );

	cadRIB -> append( "AttributeEnd\n" );

	if( !animando )
	  emit _RIBOk( );
}

void primHyper :: actualizarValores( void )
{
 	x1 = (dialogo -> x1 -> text()).toFloat();
  y1 = (dialogo -> y1 -> text()).toFloat();
  z1 = (dialogo -> z1 -> text()).toFloat();
  x2 = (dialogo -> x2 -> text()).toFloat();
  y2 = (dialogo -> y2 -> text()).toFloat();
  z2 = (dialogo -> z2 -> text()).toFloat();
 	The = (dialogo -> theta -> text()).toFloat();
   	
	this -> recalcularValoresIniciales( );

  color -> setRgb( dialogo -> color_panel -> color_object . rgb( ) );

  *nombre = dialogo -> nombre -> text( );

  emit _actualizarValor( );
}

void primHyper :: generarInterCreac( void )
{
	if ( !noGen ) {
		dialogo = new dialogo_crear_hyperboloide( 0, "", true ); //(QWidget *) this, "", true );
		
		connect( dialogo -> x1, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );	
		connect( dialogo -> y1, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> z1, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );	
		connect( dialogo -> x2, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> y2, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );	
		connect( dialogo -> z2, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> theta, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
    connect( dialogo -> color_panel, SIGNAL( _cambio( void ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> nombre, SIGNAL( textChanged( const QString & ) ), this, SIGNAL( _revisarNombre( const QString & ) ) );

    dialogo -> nombre -> setText( *nombre );
    		
   	if(dialogo -> exec())
   	{
   	  delete nombre;
   	  nombre = new QString ( dialogo -> nombre -> text( ) );
   	  delete dialogo;
   		dialogo = 0;
   	  emit _objetoCreado( );
   	}
   	else
   	{
   	  delete dialogo;
   	  dialogo = 0; 	
   	  emit _objetoNoCreado( );
   	}
   	noGen = true;
	}

}

void primHyper :: recalcularValoresIniciales( void )
{
 	GLfloat x, y, v, w, u, t, d1, d2, ang1, ang2;

 	d1 = sqrt( x1*x1 + y1*y1 );
 	ang1 = 0;
 	ang2 = 0;
 	if( x1 == 0 && y1 == 0)
 	  ang1 = 0;
 	else
 	  if( x1 >= 0 && y1 >= 0)
 	    ang1 = asin( y1 / d1 );
 	  else
 			if( x1 < 0 && y1 >= 0)
 	  		ang1 = asin( -1 * x1 / d1 ) + M_PI_2;
      else
 				if( x1 < 0 && y1 < 0)
 	  			ang1 = asin( -1 * y1 / d1 ) + M_PI;
        else
 					if( x1 >= 0 && y1 < 0)
 	  				ang1 = asin( x1 / d1 ) + M_PI + M_PI_2;
 	   	   	
 	t = M_PI*(2.0/N);

 	for(int i = 0; i < N; ++i)
 	{
    w = i*t;
    u = cos(w + ang1);
    v = sin(w + ang1);
    x = d1*u;
    y = d1*v;
    ( *(_puntos1[i]) )( 0, 0 ) = x;
    ( *(_puntos1[i]) )( 1, 0 ) = y;
    ( *(_puntos1[i]) )( 2, 0 ) = z1;
    ( *(_puntos1[i]) )( 3, 0 ) = 1.0;
 	}
 	
 	d2 = sqrt( x2*x2 + y2*y2 );

	if( x2 == 0 && y2 == 0)
 	  ang2 = 0;
 	else 	
 		if( x2 >= 0 && y2 >= 0)
 	  	ang2 = asin( y2 / d2 );
 		else	
 			if( x2 < 0 && y2 >= 0)
 	  		ang2 = asin( -1 * x2 / d2 ) + M_PI_2;
      else
 				if( x2 < 0 && y2 < 0)
 	  			ang2 = asin( -1 * y2 / d2 ) + M_PI;
				else      		
 					if( x2 >= 0 && y2 < 0)
 	  				ang2 = asin( x2 / d2 ) + M_PI + M_PI_2;
 	 	 	
 	for(int i = 0; i < N; ++i)
 	{
    w = i*t;
    u = cos(w + ang2);
    v = sin(w + ang2);
    x = d2*u;
    y = d2*v;
    ( *(_puntos2[i]) )( 0, 0 ) = x;
    ( *(_puntos2[i]) )( 1, 0 ) = y;
    ( *(_puntos2[i]) )( 2, 0 ) = z2;
    ( *(_puntos2[i]) )( 3, 0 ) = 1.0;
 	}
}

void primHyper :: encabezadoXRIB( void )
{
	if( !( matRib -> length() > 1 ) )
  	cadRIB -> sprintf( "\nHYPERBOLOID\n%s\n%s%d %d %d %.2f %.2f %.2f %.2f %.2f %.2f %.2f ", nombre -> latin1(), matRib -> latin1(), color -> red(), color -> green(), color -> blue(), x1, y1, z1, x2, y2, z2, The );
  else
  	cadRIB -> sprintf( "\nHYPERBOLOID\nMATERIAL\n%s%s\n%d %d %d %.2f %.2f %.2f %.2f %.2f %.2f %.2f ", matRib -> latin1(), nombre -> latin1(), color -> red(), color -> green(), color -> blue(), x1, y1, z1, x2, y2, z2, The );
  emit _encabezadoOK();
}

void primHyper :: genFrameXRib( void )
{
  QString  * tempoC;

  tempoC = new QString();

  cadRIB -> truncate(0);

	for (uint  n = 0 ; n < frames.count() ; n++ )
	{
    tempoC -> sprintf( "\nFRAME\n%d\n%s\n%.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f", frames . at(n) -> number,nombre -> latin1(), ( *( frames . at( n ) -> mat ) )( 0, 0 ), ( *( frames . at( n ) -> mat ) )( 1, 0 ), ( *( frames . at( n ) -> mat ) )( 2, 0 ), ( *( frames . at( n ) -> mat ) )( 3, 0 ), ( *( frames . at( n ) -> mat ) )( 0, 1 ), ( *( frames . at( n ) -> mat ) )( 1, 1 ), ( *( frames . at( n ) -> mat ) )( 2, 1 ), ( *( frames . at( n ) -> mat ) )( 3, 1 ), ( *( frames . at( n ) -> mat ) )( 0, 2 ), ( *( frames . at( n ) -> mat ) )( 1, 2 ), ( *( frames . at( n ) -> mat ) )( 2, 2 ), ( *( frames . at( n ) -> mat ) )( 3, 2 ), ( *( frames . at( n ) -> mat ) )( 0, 3 ), ( *( frames . at( n ) -> mat ) )( 1, 3 ), ( *( frames . at( n ) -> mat ) )( 2, 3 ), ( *( frames . at( n ) -> mat ) )( 3, 3 ) );
	
		cadRIB -> append( *tempoC );
	}
	
	emit _finXRIB( );

}

