/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PRIMHYPER_H
#define PRIMHYPER_H

#include "defines.h"
#include "primitiva.h"
#include "colorform_imp.h"
#include "spinboxf.h"
#include "dialogo_crear_hyperboloide.h"

class primHyper : public primitiva
{
  Q_OBJECT

	public:

		primHyper( QObject* parent, const char* name, int numFrames, GLuint Lista, QString * cadRib )
							: primitiva( parent, name, numFrames, cadRib )
		{			
			lista = Lista;
			
			x1 = 2.0;
			y1 = 3.0;
			z1 = 4.0;
			x2 = 3.0;
			y2 = -2.0;
			z2 = -4.0;
			The = 360.0;
			N = OPTHYPER;
		
			for(int i = 0; i < N; ++i)
			{
		    _puntos1[i] = new Matrix( 4, 1 );
		    _puntos2[i] = new Matrix( 4, 1 );
			}
			
			this -> recalcularValoresIniciales( );
		}
		
	  primHyper( QObject* parent, const char* name, int numFrames, GLuint Lista, QString * cadRib, QColor *Color, float X1, float Y1, float Z1, float X2, float Y2, float Z2, float theta, QString * mater )
							: primitiva( parent, name, numFrames, cadRib )
		{			
			lista = Lista;
			
			x1 = X1;
			y1 = Y1;
			z1 = Z1;
			x2 = X2;
			y2 = Y2;
			z2 = Z2;
			The = theta;
			N = OPTHYPER;
		  color = Color;
			for(int i = 0; i < N; ++i)
			{
		    _puntos1[i] = new Matrix( 4, 1 );
		    _puntos2[i] = new Matrix( 4, 1 );
			}
			
			matRib = mater;
			
			this -> recalcularValoresIniciales( );
		}
	
		~primHyper()
		{
		  for(int i = 0; i < N; ++i)
			{
		    delete _puntos1[i];
		    delete _puntos2[i];
			}
		}	
		
	public slots:
    void generarCodGL( void ); // Listo
		void generarCodRIB( void ); // Listo
		void generarInterCreac( void );
		void actualizarValores( void );
	  void recalcularValoresIniciales( void );
    void validarNombre( void ) { if( ! dialogo ) emit _validarNombre( *nombre ); }
    void encabezadoXRIB( void );
    void genFrameXRib( void );
	
	protected:
	
		float x1, x2, y1, y2, z1, z2, The;
		int N;		
	  dialogo_crear_hyperboloide * dialogo;
		pMatrix _puntos1[OPTHYPER];
		pMatrix _puntos2[OPTHYPER];

};
#endif
