/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "primPrisma.h"

void primPrisma :: generarCodGL( void )
{
	GLfloat m[16];
	pMatrix tempM;
	
	glNewList( lista, GL_COMPILE );
  if( selecc )
  	glColor3f( 1.0, 1.0, 1.0 );
	else
	  glColor3f( (GLfloat)(color -> red( ))/255.0, (GLfloat)(color -> green( ))/255.0, (GLfloat)(color -> blue( ))/255.0 );

	tempM = new Matrix( 4, 1 );
	
	* tempM = ( *( actualM -> mat ) ) * * preview ;
	
	for(int i = 0, h; i < 4; ++i)
	  for(h = 0; h < 4; ++h)
	    m[i*4+h] = ( * tempM )( h, i );

	glPushMatrix( ); 		
	glMultMatrixf( m );
	
	glBegin( GL_QUAD_STRIP );
		glVertex3f( (*_p0)( 0, 0 ), (*_p0)( 1, 0 ), (*_p0)( 2, 0 ) );
		glVertex3f( (*_p1)( 0, 0 ), (*_p1)( 1, 0 ), (*_p1)( 2, 0 ) );
		glVertex3f( (*_p3)( 0, 0 ), (*_p3)( 1, 0 ), (*_p3)( 2, 0 ) );
		glVertex3f( (*_p2)( 0, 0 ), (*_p2)( 1, 0 ), (*_p2)( 2, 0 ) );
		glVertex3f( (*_p4)( 0, 0 ), (*_p4)( 1, 0 ), (*_p4)( 2, 0 ) );
		glVertex3f( (*_p5)( 0, 0 ), (*_p5)( 1, 0 ), (*_p5)( 2, 0 ) );
		glVertex3f( (*_p7)( 0, 0 ), (*_p7)( 1, 0 ), (*_p7)( 2, 0 ) );
		glVertex3f( (*_p6)( 0, 0 ), (*_p6)( 1, 0 ), (*_p6)( 2, 0 ) );
		glVertex3f( (*_p0)( 0, 0 ), (*_p0)( 1, 0 ), (*_p0)( 2, 0 ) );
		glVertex3f( (*_p1)( 0, 0 ), (*_p1)( 1, 0 ), (*_p1)( 2, 0 ) );
	glEnd();
	glBegin( GL_QUADS );
		glVertex3f( (*_p0)( 0, 0 ), (*_p0)( 1, 0 ), (*_p0)( 2, 0 ) );
		glVertex3f( (*_p3)( 0, 0 ), (*_p3)( 1, 0 ), (*_p3)( 2, 0 ) );
		glVertex3f( (*_p4)( 0, 0 ), (*_p4)( 1, 0 ), (*_p4)( 2, 0 ) );
		glVertex3f( (*_p7)( 0, 0 ), (*_p7)( 1, 0 ), (*_p7)( 2, 0 ) );
		
		glVertex3f( (*_p1)( 0, 0 ), (*_p1)( 1, 0 ), (*_p1)( 2, 0 ) );
		glVertex3f( (*_p2)( 0, 0 ), (*_p2)( 1, 0 ), (*_p2)( 2, 0 ) );
		glVertex3f( (*_p5)( 0, 0 ), (*_p5)( 1, 0 ), (*_p5)( 2, 0 ) );
		glVertex3f( (*_p6)( 0, 0 ), (*_p6)( 1, 0 ), (*_p6)( 2, 0 ) );
	glEnd();
	glPopMatrix( );
	glEndList();
	emit _actualizacionPrimOK( );
}

void primPrisma :: generarCodRIB( void )
{
  QString * tempo;

  tempo = new QString( );
  cadRIB -> truncate( 0 );

	tempo -> sprintf( "\n\n#PRISMA %s %.2f %.2f %.2f %.2f %.2f %.2f\n\n", nombre -> latin1(), a, h, p, x, y, z );

	cadRIB -> append( * tempo );
	
	cadRIB -> append( "AttributeBegin\n" );
	
	if( !( matRib -> length() > 1 ) )
	{
	  tempo -> sprintf( "Color [ %.2f %.2f %.2f ]\n", (float)(color -> red( ))/255.0, (float)(color -> green( ))/255.0, (float)(color -> blue( ))/255.0 );
		cadRIB -> append( * tempo );
	}
	else
		cadRIB -> append( * matRib );
	
	tempo -> sprintf( "ConcatTransform %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f\n", ( *( actualM -> mat ) )( 0, 0 ), ( *( actualM -> mat ) )( 1, 0 ), -1 * ( *( actualM -> mat ) )( 2, 0 ), ( *( actualM -> mat ) )( 3, 0 ), ( *( actualM -> mat ) )( 0, 1 ), ( *( actualM -> mat ) )( 1, 1 ), -1 * ( *( actualM -> mat ) )( 2, 1 ), ( *( actualM -> mat ) )( 3, 1 ), -1 * ( *( actualM -> mat ) )( 0, 2 ), -1 * ( *( actualM -> mat ) )( 1, 2 ), ( *( actualM -> mat ) )( 2, 2 ), ( *( actualM -> mat ) )( 3, 2 ), ( *( actualM -> mat ) )( 0, 3 ), ( *( actualM -> mat ) )( 1, 3 ), -1 * ( *( actualM -> mat ) )( 2, 3 ), ( *( actualM -> mat ) )( 3, 3 ) );
	
	cadRIB -> append( * tempo );
		
	cadRIB -> append( "PointsPolygons [ 4 4 4 4 4 4 ] [ 0 1 2 3 2 3 4 5 4 5 6 7 6 7 0 1 7 0 3 4 6 1 2 5 ]\n" );
	
	tempo -> sprintf( "\"P\"[ %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f %.7f ]\n", (*_p0)( 0, 0 ), (*_p0)( 1, 0 ), -1*(*_p0)( 2, 0 ), (*_p1)( 0, 0 ), (*_p1)( 1, 0 ), -1*(*_p1)( 2, 0 ), (*_p2)( 0, 0 ), (*_p2)( 1, 0 ), -1*(*_p2)( 2, 0 ), (*_p3)( 0, 0 ), (*_p3)( 1, 0 ), -1*(*_p3)( 2, 0 ), (*_p4)( 0, 0 ), (*_p4)( 1, 0 ), -1*(*_p4)( 2, 0 ), (*_p5)( 0, 0 ), (*_p5)( 1, 0 ), -1*(*_p5)( 2, 0 ), (*_p6)( 0, 0 ), (*_p6)( 1, 0 ), -1*(*_p6)( 2, 0 ), (*_p7)( 0, 0 ), (*_p7)( 1, 0 ), -1*(*_p7)( 2, 0 ) );

	cadRIB -> append( * tempo );

	cadRIB -> append( "AttributeEnd\n" );

	if( !animando )
	  emit _RIBOk( );
}

void primPrisma :: actualizarValores( void )
{
 	a = (dialogo -> A -> text()).toFloat();
  h = (dialogo -> H -> text()).toFloat();
  p = (dialogo -> P -> text()).toFloat();
	x = (dialogo -> X -> text()).toFloat();
 	y = (dialogo -> Y -> text()).toFloat();
  z = (dialogo -> Z -> text()).toFloat();
   	
	(*_p0)( 0, 0 ) = x + a / 2.0 ;
	(*_p0)( 1, 0 ) = y + h / 2.0 ;
	(*_p0)( 2, 0 ) = z - p / 2.0 ;
			
	(*_p1)( 0, 0 ) = x + a / 2.0 ;
	(*_p1)( 1, 0 ) = y - h / 2.0 ;
	(*_p1)( 2, 0 ) = z - p / 2.0 ;
		
	(*_p2)( 0, 0 ) = x + a / 2.0 ;
	(*_p2)( 1, 0 ) = y - h / 2.0 ;
	(*_p2)( 2, 0 ) = z + p / 2.0 ;
		
	(*_p3)( 0, 0 ) = x + a / 2.0 ;
	(*_p3)( 1, 0 ) = y + h / 2.0 ;
	(*_p3)( 2, 0 ) = z + p / 2.0 ;
			
	(*_p4)( 0, 0 ) = x - a / 2.0 ;
	(*_p4)( 1, 0 ) = y + h / 2.0 ;
	(*_p4)( 2, 0 ) = z + p / 2.0 ;
		
	(*_p5)( 0, 0 ) = x - a / 2.0 ;
	(*_p5)( 1, 0 ) = y - h / 2.0 ;
	(*_p5)( 2, 0 ) = z + p / 2.0 ;
			
	(*_p6)( 0, 0 ) = x - a / 2.0 ;
	(*_p6)( 1, 0 ) = y - h / 2.0 ;
	(*_p6)( 2, 0 ) = z - p / 2.0 ;
			
	(*_p7)( 0, 0 ) = x - a / 2.0 ;
	(*_p7)( 1, 0 ) = y + h / 2.0 ;
	(*_p7)( 2, 0 ) = z - p / 2.0 ;
  color -> setRgb( dialogo -> color_panel -> color_object . rgb( ) );
  *nombre = dialogo -> nombre -> text( );

  emit _actualizarValor( );
}

void primPrisma :: generarInterCreac( void )
{
	if ( !noGen ) {
		dialogo = new dialogo_crear_prisma( 0, "", true ); //(QWidget *) this, "", true );
		
		connect( dialogo -> A, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );	
		connect( dialogo -> H, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );	
		connect( dialogo -> P, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> X, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> Y, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> Z, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
    connect( dialogo -> color_panel, SIGNAL( _cambio( void ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> nombre, SIGNAL( textChanged( const QString & ) ), this, SIGNAL( _revisarNombre( const QString & ) ) );

    dialogo -> nombre -> setText( *nombre );

    //this -> actualizarValores();
    		
   	if(dialogo -> exec())
   	{
   	  delete nombre;
   	  nombre = new QString ( dialogo -> nombre -> text( ) );   	
   		delete dialogo;
   		dialogo = 0;
   	  emit _objetoCreado( );
   	}
   	else
   	{
   		delete dialogo;
   		dialogo = 0;
   	  emit _objetoNoCreado( );
   	}

   	noGen = true; 	
	}

}

void primPrisma :: encabezadoXRIB( void )
{
	if( !( matRib -> length() > 1 ) )
  	cadRIB -> sprintf( "\nBOX\n%s\n%s%d %d %d %.2f %.2f %.2f %.2f %.2f %.2f ", nombre -> latin1(), matRib -> latin1(), color -> red(), color -> green(), color -> blue(), a, h, p, x, y, z );
  else
	  cadRIB -> sprintf( "\nBOX\nMATERIAL\n%s%s\n%d %d %d %.2f %.2f %.2f %.2f %.2f %.2f ", matRib -> latin1(), nombre -> latin1(), color -> red(), color -> green(), color -> blue(), a, h, p, x, y, z );
  emit _encabezadoOK();
}

void primPrisma :: genFrameXRib( void )
{
  QString  * tempoC;

  tempoC = new QString();

  cadRIB -> truncate(0);

	for (uint  n = 0 ; n < frames.count() ; n++ )
	{
    tempoC -> sprintf( "\nFRAME\n%d\n%s\n%.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f", frames . at(n) -> number,nombre -> latin1(), ( *( frames . at( n ) -> mat ) )( 0, 0 ), ( *( frames . at( n ) -> mat ) )( 1, 0 ), ( *( frames . at( n ) -> mat ) )( 2, 0 ), ( *( frames . at( n ) -> mat ) )( 3, 0 ), ( *( frames . at( n ) -> mat ) )( 0, 1 ), ( *( frames . at( n ) -> mat ) )( 1, 1 ), ( *( frames . at( n ) -> mat ) )( 2, 1 ), ( *( frames . at( n ) -> mat ) )( 3, 1 ), ( *( frames . at( n ) -> mat ) )( 0, 2 ), ( *( frames . at( n ) -> mat ) )( 1, 2 ), ( *( frames . at( n ) -> mat ) )( 2, 2 ), ( *( frames . at( n ) -> mat ) )( 3, 2 ), ( *( frames . at( n ) -> mat ) )( 0, 3 ), ( *( frames . at( n ) -> mat ) )( 1, 3 ), ( *( frames . at( n ) -> mat ) )( 2, 3 ), ( *( frames . at( n ) -> mat ) )( 3, 3 ) );
	
		cadRIB -> append( *tempoC );
	}
	
	emit _finXRIB( );

}

