/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PRIMPRISMA_H
#define PRIMPRISMA_H

#include "defines.h"
#include "primitiva.h"
#include "colorform_imp.h"
#include "spinboxf.h"
#include "dialogo_crear_prisma.h"

class primPrisma : public primitiva
{
  Q_OBJECT

	public:

		primPrisma( QObject* parent, const char* name, int numFrames, GLuint Lista, QString * cadRib )
							: primitiva( parent, name, numFrames, cadRib )
		{			
			lista = Lista;
			
			_p0 = new Matrix( 4, 1 );
			_p1 = new Matrix( 4, 1 );
			_p2 = new Matrix( 4, 1 );
			_p3 = new Matrix( 4, 1 );
			_p4 = new Matrix( 4, 1 );
			_p5 = new Matrix( 4, 1 );
			_p6 = new Matrix( 4, 1 );
			_p7 = new Matrix( 4, 1 );
		
      a = 5;
      h = 5;
      p = 5;
      x = 0;
      y = 0;
      z = 0;
						
			(*_p0)( 0, 0 ) = x + a / 2.0 ;
			(*_p0)( 1, 0 ) = y + h / 2.0 ;
			(*_p0)( 2, 0 ) = z - p / 2.0 ;
			
			(*_p1)( 0, 0 ) = x + a / 2.0 ;
			(*_p1)( 1, 0 ) = y - h / 2.0 ;
			(*_p1)( 2, 0 ) = z - p / 2.0 ;
		
			(*_p2)( 0, 0 ) = x + a / 2.0 ;
			(*_p2)( 1, 0 ) = y - h / 2.0 ;
			(*_p2)( 2, 0 ) = z + p / 2.0 ;
		
			(*_p3)( 0, 0 ) = x + a / 2.0 ;
			(*_p3)( 1, 0 ) = y + h / 2.0 ;
			(*_p3)( 2, 0 ) = z + p / 2.0 ;
			
			(*_p4)( 0, 0 ) = x - a / 2.0 ;
			(*_p4)( 1, 0 ) = y + h / 2.0 ;
			(*_p4)( 2, 0 ) = z + p / 2.0 ;
			
			(*_p5)( 0, 0 ) = x - a / 2.0 ;
			(*_p5)( 1, 0 ) = y - h / 2.0 ;
			(*_p5)( 2, 0 ) = z + p / 2.0 ;
			
			(*_p6)( 0, 0 ) = x - a / 2.0 ;
			(*_p6)( 1, 0 ) = y - h / 2.0 ;
			(*_p6)( 2, 0 ) = z - p / 2.0 ;
			
			(*_p7)( 0, 0 ) = x - a / 2.0 ;
			(*_p7)( 1, 0 ) = y + h / 2.0 ;
			(*_p7)( 2, 0 ) = z - p / 2.0 ;
		}

		primPrisma( QObject* parent, const char* name, int numFrames, GLuint Lista, QString * cadRib, QColor *Color, float A, float H, float P, float X, float Y, float Z, QString * mater )
							: primitiva( parent, name, numFrames, cadRib )
		{			
			lista = Lista;
			
			_p0 = new Matrix( 4, 1 );
			_p1 = new Matrix( 4, 1 );
			_p2 = new Matrix( 4, 1 );
			_p3 = new Matrix( 4, 1 );
			_p4 = new Matrix( 4, 1 );
			_p5 = new Matrix( 4, 1 );
			_p6 = new Matrix( 4, 1 );
			_p7 = new Matrix( 4, 1 );
		
			a = A;
      h = H;
      p = P;
      x = X;
      y = Y;
      z = Z;
      color = Color;
						
			(*_p0)( 0, 0 ) = x + a / 2.0 ;
			(*_p0)( 1, 0 ) = y + h / 2.0 ;
			(*_p0)( 2, 0 ) = z - p / 2.0 ;
			
			(*_p1)( 0, 0 ) = x + a / 2.0 ;
			(*_p1)( 1, 0 ) = y - h / 2.0 ;
			(*_p1)( 2, 0 ) = z - p / 2.0 ;
		
			(*_p2)( 0, 0 ) = x + a / 2.0 ;
			(*_p2)( 1, 0 ) = y - h / 2.0 ;
			(*_p2)( 2, 0 ) = z + p / 2.0 ;
		
			(*_p3)( 0, 0 ) = x + a / 2.0 ;
			(*_p3)( 1, 0 ) = y + h / 2.0 ;
			(*_p3)( 2, 0 ) = z + p / 2.0 ;
			
			(*_p4)( 0, 0 ) = x - a / 2.0 ;
			(*_p4)( 1, 0 ) = y + h / 2.0 ;
			(*_p4)( 2, 0 ) = z + p / 2.0 ;
			
			(*_p5)( 0, 0 ) = x - a / 2.0 ;
			(*_p5)( 1, 0 ) = y - h / 2.0 ;
			(*_p5)( 2, 0 ) = z + p / 2.0 ;
			
			(*_p6)( 0, 0 ) = x - a / 2.0 ;
			(*_p6)( 1, 0 ) = y - h / 2.0 ;
			(*_p6)( 2, 0 ) = z - p / 2.0 ;
			
			(*_p7)( 0, 0 ) = x - a / 2.0 ;
			(*_p7)( 1, 0 ) = y + h / 2.0 ;
			(*_p7)( 2, 0 ) = z - p / 2.0 ;
			
		  matRib = mater;
		
		}
		
		~primPrisma()
		{
		  //glDeleteLists(lista, 1);
		}

	public slots:
    void generarCodGL( void ); // Listo
		void generarCodRIB( void ); // Listo
		void generarInterCreac( void  );
		void actualizarValores( void );
    void validarNombre( void ) { if( ! dialogo ) emit _validarNombre( *nombre ); }
    void encabezadoXRIB( void );
    void genFrameXRib( void );
	protected:

	  float a,h,p,x,y,z;
		
		pMatrix _p0;
		pMatrix _p1;
		pMatrix _p2;
		pMatrix _p3;
		pMatrix _p4;
		pMatrix _p5;
		pMatrix _p6;
		pMatrix _p7;
		
		dialogo_crear_prisma * dialogo;

};
#endif
