/***************************************************************************
    begin                : Mon Jul  2 23:00:58 COT 2001
    copyright            : (C) 2001 by Vctor Javier Cerquera, Alejandro Gutirrez
    email                : <javier@gaia.univalle.edu.co>
    											 <alejandro@calipso.com.co>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "primToro.h"

void primToro :: generarCodGL( void )
{
	GLfloat m[16];
	pMatrix tempM;
	
	glNewList( lista, GL_COMPILE );

  if( selecc )
  	glColor3f( 1.0, 1.0, 1.0 );
	else
	  glColor3f( (GLfloat)(color -> red( ))/255.0, (GLfloat)(color -> green( ))/255.0, (GLfloat)(color -> blue( ))/255.0 );	

	tempM = new Matrix( 4, 1 );
	
	* tempM = ( *( actualM -> mat ) ) * * preview ;
	
	for(int i = 0, h; i < 4; ++i)
	  for(h = 0; h < 4; ++h)
	    m[i*4+h] = ( * tempM )( h, i );

	glPushMatrix( ); 		
	glMultMatrixf( m );
	  	
  for(int i = 0, h; i < indEx; ++i)
  {
    for(h = indIn - 1; h < indIn2; ++h)
	  {
   		glBegin(GL_POLYGON);
    		glVertex3f(( *(_puntos[i][h]) )( 0, 0 ), ( *(_puntos[i][h]) )( 1, 0 ), ( *(_puntos[i][h]) )( 2, 0 ) );
    		glVertex3f(( *(_puntos[i][h + 1]) )( 0, 0 ), ( *(_puntos[i][h + 1]) )( 1, 0 ), ( *(_puntos[i][h + 1]) )( 2, 0 ) );
    		glVertex3f(( *(_puntos[i + 1][h + 1]) )( 0, 0 ), ( *(_puntos[i + 1][h + 1]) )( 1, 0 ), ( *(_puntos[i + 1][h + 1]) )( 2, 0 ) );
    		glVertex3f(( *(_puntos[i + 1][h]) )( 0, 0 ), ( *(_puntos[i + 1][h]) )( 1, 0 ), ( *(_puntos[i + 1][h]) )( 2, 0 ) );
   		glEnd();
  	}
 	}
  glPopMatrix( );
	glEndList();
	emit _actualizacionPrimOK( );
}

void primToro :: generarCodRIB( void )
{
  QString * tempo;

  tempo = new QString( );
  cadRIB -> truncate( 0 );
	
	tempo -> sprintf( "\n\n#TORO %s %0.2f %0.2f %0.2f %0.2f %0.2f\n\n", nombre -> latin1(), Ry, Rm, N1, N2, M );

	cadRIB -> append( * tempo );

	cadRIB -> append( "AttributeBegin\n" );
	
	if( !( matRib -> length() > 1 ) )
	{
	  tempo -> sprintf( "Color [ %.2f %.2f %.2f ]\n", (float)(color -> red( ))/255.0, (float)(color -> green( ))/255.0, (float)(color -> blue( ))/255.0 );
		cadRIB -> append( * tempo );
	}
	else
		cadRIB -> append( * matRib );
	
	tempo -> sprintf( "ConcatTransform %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f\n", ( *( actualM -> mat ) )( 0, 0 ), ( *( actualM -> mat ) )( 1, 0 ), -1 * ( *( actualM -> mat ) )( 2, 0 ), ( *( actualM -> mat ) )( 3, 0 ), ( *( actualM -> mat ) )( 0, 1 ), ( *( actualM -> mat ) )( 1, 1 ), -1 * ( *( actualM -> mat ) )( 2, 1 ), ( *( actualM -> mat ) )( 3, 1 ), -1 * ( *( actualM -> mat ) )( 0, 2 ), -1 * ( *( actualM -> mat ) )( 1, 2 ), ( *( actualM -> mat ) )( 2, 2 ), ( *( actualM -> mat ) )( 3, 2 ), ( *( actualM -> mat ) )( 0, 3 ), ( *( actualM -> mat ) )( 1, 3 ), -1 * ( *( actualM -> mat ) )( 2, 3 ), ( *( actualM -> mat ) )( 3, 3 ) );
	
	cadRIB -> append( * tempo );
		
	tempo -> sprintf( "Torus %0.2f %0.2f %0.2f %0.2f %0.2f\n", Ry, Rm, N1, N2, M );

	cadRIB -> append( * tempo );

	cadRIB -> append( "AttributeEnd\n" );

	if( !animando )
	  emit _RIBOk( );
}

void primToro :: actualizarValores( void )
{
 	Ry = (dialogo -> maxradius -> text()).toFloat();
  Rm = (dialogo -> minradius -> text()).toFloat();
  N2 = (dialogo -> phimax -> text()).toFloat();
	N1 = (dialogo -> phimin -> text()).toFloat();
 	M = (dialogo -> theta -> text()).toFloat();
   	
	this -> recalcularValoresIniciales( );

  color -> setRgb( dialogo -> color_panel -> color_object . rgb( ) );

  *nombre = dialogo -> nombre -> text( );

  emit _actualizarValor( );
}

void primToro :: generarInterCreac( void )
{
	if ( !noGen ) {
		dialogo = new dialogo_crear_toro( 0, "", true ); //(QWidget *) this, "", true );
		
		connect( dialogo -> maxradius, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );	
		connect( dialogo -> minradius, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );	
		connect( dialogo -> phimax, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> phimin, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> theta, SIGNAL( valueChanged( int ) ), this, SLOT( actualizarValores( ) ) );		
    connect( dialogo -> color_panel, SIGNAL( _cambio( void ) ), this, SLOT( actualizarValores( ) ) );		
		connect( dialogo -> nombre, SIGNAL( textChanged( const QString & ) ), this, SIGNAL( _revisarNombre( const QString & ) ) );

    dialogo -> nombre -> setText( *nombre );
    		
   	if(dialogo -> exec())
   	{
   	  delete nombre;
   	  nombre = new QString ( dialogo -> nombre -> text( ) );
   	  delete dialogo;
   		dialogo = 0;
   	  emit _objetoCreado( );
   	}
   	else
   	{
   	  delete dialogo;
   		dialogo = 0;
   	  emit _objetoNoCreado( );
   	}
   	
   	noGen = true;
	}

}

void primToro :: recalcularValoresIniciales( void )
{
 float x, y, z, v, t, u;

 indIn = (int)ceil( N1*factIn );
 indIn2 = (int)floor( N2*factIn );
 indEx = (int)floor( M*factEx );

 if( ( indIn - ( N1*factIn ) ) == 0 )
   ++indIn;

 if( ( indIn2 - ( N2*factIn ) ) == 0 )
   --indIn2;

 if( ( indEx - ( M*factEx ) ) == 0 )
   --indEx;

 for(int i = 0, h; i <= indEx; ++i)
 {
   u = i*M_PI/180.0;    // ngulo Mayor /180.0
   u /= factEx;

   t = N1*M_PI/180.0;  // ngulo Menor /180.0
   v = Rm*cos(t);
   x = (Ry+v)*cos(u);
   y = (Ry+v)*sin(u);
   z = -1 * Rm*sin(t);

   ( *(_puntos[i][indIn - 1]) )( 0, 0 ) = x;
   ( *(_puntos[i][indIn - 1]) )( 1, 0 ) = y;
   ( *(_puntos[i][indIn - 1]) )( 2, 0 ) = z;
   ( *(_puntos[i][indIn - 1]) )( 3, 0 ) = 1.0;

   for(h = indIn; h <= indIn2; ++h)
   {
    t = h*M_PI/180.0;  // ngulo Menor /180.0
    t /= factIn;
    v = Rm*cos(t);
    x = (Ry+v)*cos(u);
    y = (Ry+v)*sin(u);
    z = -1 * Rm*sin(t);

    ( *(_puntos[i][h]) )( 0, 0 ) = x;
    ( *(_puntos[i][h]) )( 1, 0 ) = y;
    ( *(_puntos[i][h]) )( 2, 0 ) = z;
    ( *(_puntos[i][h]) )( 3, 0 ) = 1.0;
   }

   t = N2*M_PI/180.0;  // ngulo Menor /180.0
   v = Rm*cos(t);
   x = (Ry+v)*cos(u);
   y = (Ry+v)*sin(u);
   z = -1 * Rm*sin(t);

   ( *(_puntos[i][indIn2 + 1]) )( 0, 0 ) = x;
   ( *(_puntos[i][indIn2 + 1]) )( 1, 0 ) = y;
   ( *(_puntos[i][indIn2 + 1]) )( 2, 0 ) = z;
   ( *(_puntos[i][indIn2 + 1]) )( 3, 0 ) = 1.0;
 }		
 		
 u = M*M_PI/180.0;    // ngulo Mayor /180.0

 t = N1*M_PI/180.0;  // ngulo Menor /180.0
 v = Rm*cos(t);
 x = (Ry+v)*cos(u);
 y = (Ry+v)*sin(u);
 z = -1 * Rm*sin(t);

 ( *(_puntos[indEx + 1][indIn - 1]) )( 0, 0 ) = x;
 ( *(_puntos[indEx + 1][indIn - 1]) )( 1, 0 ) = y;
 ( *(_puntos[indEx + 1][indIn - 1]) )( 2, 0 ) = z;
 ( *(_puntos[indEx + 1][indIn - 1]) )( 3, 0 ) = 1.0;

 for(int h = indIn; h <= indIn2; ++h)
 {
   t = h*M_PI/180.0;  // ngulo Menor /180.0
   t /= factIn;
   v = Rm*cos(t);
   x = (Ry+v)*cos(u);
   y = (Ry+v)*sin(u);
   z = -1 * Rm*sin(t);

   ( *(_puntos[indEx + 1][h]) )( 0, 0 ) = x;
   ( *(_puntos[indEx + 1][h]) )( 1, 0 ) = y;
   ( *(_puntos[indEx + 1][h]) )( 2, 0 ) = z;
   ( *(_puntos[indEx + 1][h]) )( 3, 0 ) = 1.0;
 }

 t = N2*M_PI/180.0;  // ngulo Menor /180.0
 v = Rm*cos(t);
 x = (Ry+v)*cos(u);
 y = (Ry+v)*sin(u);
 z = -1 * Rm*sin(t);

 ( *(_puntos[indEx + 1][indIn2 + 1]) )( 0, 0 ) = x;
 ( *(_puntos[indEx + 1][indIn2 + 1]) )( 1, 0 ) = y;
 ( *(_puntos[indEx + 1][indIn2 + 1]) )( 2, 0 ) = z;
 ( *(_puntos[indEx + 1][indIn2 + 1]) )( 3, 0 ) = 1.0;

}

void primToro :: encabezadoXRIB( void )
{
	if( !( matRib -> length() > 1 ) )
	  cadRIB -> sprintf( "\nTORUS\n%s\n%s%d %d %d %.2f %.2f %.2f %.2f %.2f ", nombre -> latin1(), matRib -> latin1(), color -> red(), color -> green(), color -> blue(), Rm, Ry, N1, N2, M );
	else
	  cadRIB -> sprintf( "\nTORUS\nMATERIAL\n%s%s\n%d %d %d %.2f %.2f %.2f %.2f %.2f ", matRib -> latin1(), nombre -> latin1(), color -> red(), color -> green(), color -> blue(), Rm, Ry, N1, N2, M );
  emit _encabezadoOK();
}

void primToro :: genFrameXRib( void )
{
  QString  * tempoC;

  tempoC = new QString();

  cadRIB -> truncate(0);

	for (uint  n = 0 ; n < frames.count() ; n++ )
	{
    tempoC -> sprintf( "\nFRAME\n%d\n%s\n%.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f", frames . at(n) -> number,nombre -> latin1(), ( *( frames . at( n ) -> mat ) )( 0, 0 ), ( *( frames . at( n ) -> mat ) )( 1, 0 ), ( *( frames . at( n ) -> mat ) )( 2, 0 ), ( *( frames . at( n ) -> mat ) )( 3, 0 ), ( *( frames . at( n ) -> mat ) )( 0, 1 ), ( *( frames . at( n ) -> mat ) )( 1, 1 ), ( *( frames . at( n ) -> mat ) )( 2, 1 ), ( *( frames . at( n ) -> mat ) )( 3, 1 ), ( *( frames . at( n ) -> mat ) )( 0, 2 ), ( *( frames . at( n ) -> mat ) )( 1, 2 ), ( *( frames . at( n ) -> mat ) )( 2, 2 ), ( *( frames . at( n ) -> mat ) )( 3, 2 ), ( *( frames . at( n ) -> mat ) )( 0, 3 ), ( *( frames . at( n ) -> mat ) )( 1, 3 ), ( *( frames . at( n ) -> mat ) )( 2, 3 ), ( *( frames . at( n ) -> mat ) )( 3, 3 ) );
	
		cadRIB -> append( *tempoC );
	}
	
	emit _finXRIB( );

}

